#ifndef __ADDINQUEUE_H

#define __ADDINQUEUE_H

#include "class.h"
#include "queue.h"
#include "filetype.h"

typedef int _System AddInQueueCallBackNodeFound( Queue *que, 
                                                 Address *addr,
                                                 Traffic *traf );
typedef int _System AddInQueueCallBackSend( char *path, char *alias, FileProcess mode );
                    // ret: 0 - OK, -1 - ERROR, 1 - SKIP, 2 - REFUSE

typedef void LOGFunc( char* ... );

typedef int  _System AddInQueueInit( char *params, LOGFunc log );
typedef void _System AddInQueueDone();
typedef void _System AddInQueueScanInit();
typedef void _System AddInQueueScanDone();
typedef void _System AddInQueueScan( Queue *, AddInQueueCallBackNodeFound * );
typedef void _System AddInQueueSendInit( Address * );
typedef void _System AddInQueueSendDone();
typedef int  _System AddInQueueSend( Address *, Flavour, FileType, AddInQueueCallBackSend * );

class AddInQueue : public BaseObject
{
  char *name;
  char *params;
  HMODULE handle;
  AddInQueueInit     *init;
  AddInQueueDone     *done;
  AddInQueueScanInit *scanInit;
  AddInQueueScanDone *scanDone;
  AddInQueueScan     *scan;
  AddInQueueSendInit *sendInit;
  AddInQueueSendDone *sendDone;
  AddInQueueSend     *send;
  
  int equal( const BaseObject &t ) const;
  char *nameOfClass() const;
  void print( ostream& ) const;

public:
  AddInQueue( char *dll, char *par);
  ~AddInQueue();

  void scanQueue( Queue * );
  void sendAddress( Address *addr );

  char *getName() const { return name; }
  char *getParams() const { return params; }
};

class AddInQueueList : public Collection
{
public:
  AddInQueueList();
  AddInQueue* Find( AddInQueue& item, LockMode lock=LockModeNeed ) const;
  AddInQueue& operator [] ( const int pos ) const;

  void scan( Queue * );
};

class AddInQueueIterator : public CollectionIterator
{
public:
  AddInQueueIterator( AddInQueueList& ini );
  AddInQueue& operator () () const;
};

extern AddInQueueList *addInQueueList;

#endif