#include <stdio.h>
#include <time.h>
#include <share.h>
#include <fcntl.h>
#include <io.h>

#include "language.h"

#include "misc.h"
#include "ea.h"

/*
   0 - answer
   1 - dial
   2 - terminal
   3 - bbs
   4 - external
   5 - income ses
   6 - outgoing ses
   7 - empty
   254 - version
*/

static const char binaryLogVersion = 0x01;

void writeToBinaryLog( char code, void *buf, int len, long stamp )
{
  if( miscInfo.binLogName==NULL )
    return;

  makeFilePath( miscInfo.binLogName );

  FILE *bin = _fsopen( miscInfo.binLogName, "ab" );

  if( bin==NULL )
  {
    log( Msg_ErrNoAccess, miscInfo.binLogName, strError() );
    return;
  }

  int needEa( filelength( fileno( bin ) )==0 );

  if( !stamp )
    time( &stamp );

  if( fwrite( &stamp, 1, sizeof( stamp ), bin )!=sizeof( stamp ) )
write_error:
    log( Msg_ErrUnableWrite, miscInfo.binLogName, strError() );
  else
  {
    if( needEa )
    {
      char ver[2] = { 254, binaryLogVersion };

      if( fwrite( ver, 1, sizeof( ver ), bin )!=sizeof( ver ) )
        goto write_error;

      if( fwrite( &stamp, 1, sizeof( stamp ), bin )!=sizeof( stamp ) )
        goto write_error;
    }

    if( fwrite( &code, 1, sizeof( code ), bin )!=sizeof( code ) )
      goto write_error;

    if( len )
      if( fwrite( buf, 1, len, bin )!=len )
        goto write_error;
  }

  fclose( bin );

  if( needEa )
    setExtendedAttribute( miscInfo.binLogName, ".TYPE", Msg_EABinLog );
}
