#ifndef __BOXITEM_H

#define __BOXITEM_H

#include <time.h>

#include "class.h"
#include "newstr.h"

enum Priority
{
  NetMail  = 0,
  EchoMail = 1,
  Request  = 2,
  File     = 3
};

class BoxItem : public BaseObject
{
  char *name;
  Priority prio;
  unsigned long created;
  
  int equal( const BaseObject &t ) const;
  char *nameOfClass() const;
  void print( ostream& ) const;

public:
  BoxItem( char *nm, Priority p, unsigned long crea );
  ~BoxItem();

  char *getName() const { return name; }
  int less( const BoxItem &cmp ) const;
};

class BoxItemList : public Collection
{
public:
  BoxItemList();

  BoxItem* Find( BoxItem& item, LockMode lock=LockModeNeed ) const;
  BoxItem& operator [] ( const int pos ) const;

  void sort();
};

class BoxItemIterator : public CollectionIterator
{
public:
  BoxItemIterator( BoxItemList& ini );
  
  BoxItem& operator () () const;
};

#endif