#define INCL_DOS
#define INCL_DOSDATETIME
#define INCL_DOSPROCESS
#include <os2.h>

#include <string.h>

inline int tolower (int c)
{
  if (c >= 'A' && c <= 'Z')
    return c + 'a' - 'A';
  else
    return c;
}

inline int stricmp( const char *string1, const char *string2 )
{
  int d;

  while( 1 )
    {
      d = tolower ((unsigned char)*string1)
        - tolower ((unsigned char)*string2);
      if (d != 0 || *string1 == 0 || *string2 == 0)
        return d;
      ++string1; ++string2;
    }
}

inline void nultoa( unsigned long p, char *buf )
{
  int i=0;

  buf += strlen(buf);

  for( i=0; i<8; i++ )
  {
    char ch = (char)((p&0xf0000000l)>>28);

    p <<= 4;

    if( ch<10 )
      ch += (char)'0';
    else
      ch += (char)('A'-10);

    *buf = ch;
    ++buf;
  }

  *buf = 0;
}

static char * getTracePointLocation( unsigned long segment,
                                     unsigned long offset )
{
  static char buf[ 1024*4 ];
  int i = 0;

  for( i = 1; internalModuleList[i].seg; i++ )
    if( internalModuleList[i].seg>segment || internalModuleList[i].off>offset )
    {
      --i;

      strcpy( buf, internalModuleList[i].type );
      strcat( buf, ", " );
      strcat( buf, internalModuleList[i].module );
      strcat( buf, " @ " );
      strcat( buf, internalModuleList[i].func );
      strcat( buf, "+0x" );
      nultoa( offset-internalModuleList[i].off, buf );

      return buf;
    }

  return strcpy( buf, "*Not found in location DataBase*" );
}

#define DosQueryModFromEIP DOSQUERYMODFROMEIP

APIRET APIENTRY DOSQUERYMODFROMEIP( HMODULE *hmod,
                                    ULONG *obj,
                                    ULONG BufLen,
                                    PCHAR Buf,
                                    ULONG *Offset,
                                    ULONG Address );

// न   360. ᪠  DOSCALLS.DLL.


inline void lultoa( unsigned int tm, char *buf, char *ch, int how=4 )
{
  int i = strlen(buf);
  int d = 0;

  if( how==5 )
  {
    d = 1;
    buf[i+0] = char(((tm/10000)%10)+'0');
  }

  buf[i+0+d] = char(((tm/1000)%10)+'0');
  buf[i+1+d] = char(((tm/100)%10)+'0');
  buf[i+2+d] = char(((tm/10)%10)+'0');
  buf[i+3+d] = char((tm%10)+'0');
  strcpy( buf+i+4+d, ch );
}

inline void multoa( unsigned int tm, char *buf, char ch )
{
  int i = strlen(buf);

  buf[i+0] = char(((tm/10)%10)+'0');
  buf[i+1] = char((tm%10)+'0');
  buf[i+2] = ch;
  buf[i+3] = char(0);
}

inline void nultoa( ULONG p, char *buf, char *msg, int how=8 )
{
  buf += strlen(buf);
  p <<= 4*(8-how);

  for( int i=0; i<how; i++ )
  {
    char ch = char((p&0xf0000000l)>>28);

    p <<= 4;

    if( ch<10 )
      ch += char('0');
    else
      ch += char('a'-10);

    *buf = ch;
    ++buf;
  }

  strcpy( buf, msg );
}

inline void decimal( ULONG p, char *buf )
{
  char ptr[32],
       *bb = ptr+sizeof(ptr)-2;

  bb[1] = 0;

  do
  {
    *bb = char( (p%10)+'0' );
    p /= 10;
    --bb;
  }
  while( p );

  strcat( buf+strlen(buf), bb+1 );
}

static void address( ULONG p, char *buf )
{
  HMODULE hmod;
  ULONG obj;
  char loc[80];
  ULONG off;

  nultoa( p, buf, " (" );

  if( !DosQueryModFromEIP( &hmod, &obj, sizeof( loc ), loc, &off, p ) )
  {
    multoa( (unsigned int)obj, buf, ':' );
    nultoa( off, buf, " " );
    strcat( buf, loc );

    if( !stricmp( loc, "BRAKE" ) )
    {
      strcat( buf, ", " );
      strcat( buf, getTracePointLocation( obj+1, off ) );
    }

    strcat( buf, ")" );
  }
  else
    strcat( buf, "*Can`t decode*)" );
}

static APIRET APIENTRY writeDump( char *outBuffer, int taskNumber )
{
  ULONG handle;
  ULONG action;
  char name[32];

  strcpy( name, "$Trace." );
  decimal( taskNumber, name );

  APIRET rc = DosOpen( name, (ULONG *)&handle, &action,
		  0,
		  FILE_NORMAL,
		  OPEN_ACTION_CREATE_IF_NEW|OPEN_ACTION_OPEN_IF_EXISTS,
		  OPEN_SHARE_DENYNONE|OPEN_ACCESS_READWRITE,
		  0 );

  if( rc )
  {
    handle = 1;
    strcat( outBuffer, "\r\n *** DosOpen=" );
    decimal( (ULONG)rc, name );
    strcat( outBuffer, name );
  }
  else
    DosSetFilePtr( handle, 0, FILE_END, &action );

  strcat( outBuffer, "\r\n" );
  DosWrite( handle, (void *)outBuffer, strlen(outBuffer), &action );

  if( handle!=1 )
    DosClose( handle );

  return rc;
}

inline void pair( char *msg, ULONG num, int how, char *outBuffer )
{
  strcat( outBuffer, msg );
  nultoa( num, outBuffer, "", how );
}

static APIRET APIENTRY dumpAccess( ULONG p, char *outBuffer )
{
  switch( (unsigned int)p )
  {
  case XCPT_DATA_UNKNOWN:
    strcat( outBuffer, "DATA UNKNOWN" );
    break;

  case XCPT_UNKNOWN_ACCESS:
    strcat( outBuffer, "UNKNOWN ACCESS" );
    break;

  case XCPT_READ_ACCESS:
    strcat( outBuffer, "READ" );
    break;

  case XCPT_WRITE_ACCESS:
    strcat( outBuffer, "WRITE" );
    break;

  case XCPT_EXECUTE_ACCESS:
    strcat( outBuffer, "EXECUTE" );
    break;

  case XCPT_SPACE_ACCESS:
    strcat( outBuffer, "SPACE" );
    break;

  case XCPT_LIMIT_ACCESS:
    strcat( outBuffer, "LIMIT" );
    break;

  default:
    strcat( outBuffer, "TYPE=" );
    nultoa( p, outBuffer, "" );
  }

  return 0;
}

APIRET APIENTRY displayContext( PCONTEXTRECORD p, PEXCEPTIONREPORTRECORD p1,
                                int taskNumber,
                                const char *M_NAME,
                                char *M_NUMBER,
                                const char *M_VERSION )
{
  char *outBuffer;
  char buf[ 256 ];

  APIRET rc = DosAllocMem( (PPVOID)&outBuffer, 1024*1024, PAG_READ|PAG_WRITE|PAG_COMMIT );

  if( rc )
  {
    outBuffer = buf;
    strcpy( buf, "\r\n\r\n*** DosAllocMem error, unable handle exception at " );

    address( (ULONG)p1->ExceptionAddress, outBuffer );
    strcat( outBuffer, "\r\n\r\n" );
  }
  else
  {
    PTIB tib;
    PPIB pib;
    DATETIME dateTime;

    DosGetInfoBlocks( &tib, &pib );
    DosGetDateTime( &dateTime );

    strcpy( outBuffer, "* Dump at " );
    multoa( dateTime.day,     outBuffer, '/' );
    multoa( dateTime.month,   outBuffer, '/' );
    multoa( dateTime.year,    outBuffer, ' ' );
    multoa( dateTime.hours,   outBuffer, ':' );
    multoa( dateTime.minutes, outBuffer, ':' );
    multoa( dateTime.seconds, outBuffer, ' ' );

    strcat( outBuffer, "for PID " );
    nultoa( pib->pib_ulpid, outBuffer, ", TID ", 4 );
    multoa( (unsigned int)tib->tib_ptib2->tib2_ultid, outBuffer, 0 );
    strcat( outBuffer, ", " );
    strcat( outBuffer, M_NAME );
    strcat( outBuffer, " " );
    strcat( outBuffer, M_VERSION );
    strcat( outBuffer, "/" );
    strcat( outBuffer, M_NUMBER );
    strcat( outBuffer, "\r\n" );
  
    char *name = "UNKNOWN";

    switch( (unsigned int)p1->ExceptionNum )
    {
    case XCPT_ACCESS_VIOLATION:
      name = "ACCESS VIOLATION";
      break;

    case XCPT_INTEGER_DIVIDE_BY_ZERO:
      name = "INTEGER DIVIDE BY ZERO";
      break;

    case XCPT_FLOAT_DIVIDE_BY_ZERO:
      name = "FLOAT DIVIDE BY ZERO";
      break;

    case XCPT_FLOAT_INVALID_OPERATION:
      name = "FLOAT INVALID OPERATION";
      break;

    case XCPT_ILLEGAL_INSTRUCTION:
      name = "ILLEGAL INSTRUCTION";
      break;

    case XCPT_PRIVILEGED_INSTRUCTION:
      name = "PRIVILEGED INSTRUCTION";
      break;

    case XCPT_INTEGER_OVERFLOW:
      name = "INTEGER OVERFLOW";
      break;

    case XCPT_FLOAT_OVERFLOW:
      name = "FLOAT OVERFLOW";
      break;

    case XCPT_FLOAT_UNDERFLOW:
      name = "FLOAT UNDERFLOW";
      break;

    case XCPT_FLOAT_DENORMAL_OPERAND:
      name = "FLOAT DENORMAL OPERAND";
      break;

    case XCPT_FLOAT_INEXACT_RESULT:
      name = "FLOAT INEXACT RESULT";
      break;

    case XCPT_FLOAT_STACK_CHECK:
      name = "FLOAT STACK CHECK";
      break;

    case XCPT_DATATYPE_MISALIGNMENT:
      name = "DATATYPE MISALIGNMENT";
      break;

    case XCPT_UNABLE_TO_GROW_STACK:
      name = "UNABLE TO GROW STACK";
      break;

    case XCPT_IN_PAGE_ERROR:
      name = "IN PAGE ERROR";
      break;

    case XCPT_NONCONTINUABLE_EXCEPTION:
      name = "NONCONTINUABLE EXCEPTION";
      break;

    case XCPT_INVALID_DISPOSITION:
      name = "INVALID DISPOSITION";
      break;

    case XCPT_INVALID_LOCK_SEQUENCE:
      name = "INVALID LOCK SEQUENCE";
      break;

    case XCPT_ARRAY_BOUNDS_EXCEEDED:
      name = "ARRAY BOUNDS EXCEEDED";
      break;

    case XCPT_B1NPX_ERRATA_02:
      name = "B1NPX ERRATA 02";
      break;

    case XCPT_UNWIND:
      name = "UNWIND";
      break;

    case XCPT_BAD_STACK:
      name = "BAD STACK";
      break;

    case XCPT_INVALID_UNWIND_TARGET:
      name = "INVALID UNWIND TARGET";
      break;

    case XCPT_BREAKPOINT:
      name = "BREAKPOINT";
      break;

    case XCPT_SINGLE_STEP:
      name = "SINGLE STEP";
      break;
    }

    pair( "# Exception ", p1->ExceptionNum, 8, outBuffer );
    strcat( outBuffer, " -> " );
    strcat( outBuffer, name );
    strcat( outBuffer, " at " );

    address( (ULONG)p1->ExceptionAddress, outBuffer );
    strcat( outBuffer, "\r\n# Flag:" );

    char flagWas(0);

    if( (p1->fHandlerFlags&EH_NONCONTINUABLE)==EH_NONCONTINUABLE )
    {
      strcat( outBuffer, " NONCONTINUABLE" );
      flagWas = 1;
    }
  
    if( (p1->fHandlerFlags&EH_UNWINDING)==EH_UNWINDING )
    {
      strcat( outBuffer, " UNWINDING" );
      flagWas = 1;
    }
  
    if( (p1->fHandlerFlags&EH_EXIT_UNWIND)==EH_EXIT_UNWIND )
    {
      strcat( outBuffer, " EXIT_UNWIND" );
      flagWas = 1;
    }
  
    if( (p1->fHandlerFlags&EH_STACK_INVALID)==EH_STACK_INVALID )
    {
      strcat( outBuffer, " STACK_INVALID" );
      flagWas = 1;
    }
  
    if( (p1->fHandlerFlags&EH_NESTED_CALL)==EH_NESTED_CALL )
    {
      strcat( outBuffer, " NESTED_CALL" );
      flagWas = 1;
    }

    if( !flagWas )
      strcat( outBuffer, " NO_FLAGs" );

    strcat( outBuffer, "\r\n" );
  
    switch( (unsigned int)p1->ExceptionNum )
    {
    case XCPT_ACCESS_VIOLATION:
      strcat( outBuffer, "# Fault " );
      dumpAccess( p1->ExceptionInfo[0], outBuffer );
      strcat( outBuffer, " for " );
      address( p1->ExceptionInfo[1], outBuffer );
      strcat( outBuffer, "\r\n" );
      break;

    case XCPT_DATATYPE_MISALIGNMENT:
      strcat( outBuffer, "# Fault " );
      dumpAccess( p1->ExceptionInfo[0], outBuffer );
      strcat( outBuffer, " for " );
      address( p1->ExceptionInfo[2], outBuffer );
      strcat( outBuffer, " need ALIGN by " );
      nultoa( p1->ExceptionInfo[1], outBuffer, "\r\n" );
      break;

    case XCPT_IN_PAGE_ERROR:
      strcat( outBuffer, "# Fault address is " );
      address( p1->ExceptionInfo[0], outBuffer );
      strcat( outBuffer, "\r\n" );
    }

    pair( "# CS:EIP ", p->ctx_SegCs, 4, outBuffer );
    pair( ":", p->ctx_RegEip, 8, outBuffer );
    pair( "   SS:ESP ", p->ctx_SegSs, 4, outBuffer );
    pair( ":", p->ctx_RegEsp, 8, outBuffer );
    pair( "   EBP:", p->ctx_RegEbp, 8, outBuffer );
    strcat( outBuffer, "\r\n" );

    pair( "# ES:", p->ctx_SegEs, 4, outBuffer );
    pair( "   DS:", p->ctx_SegDs, 4, outBuffer );
    pair( "   GS:", p->ctx_SegGs, 4, outBuffer );
    pair( "   FS:", p->ctx_SegFs, 4, outBuffer );
    strcat( outBuffer, "\r\n" );

    pair( "# EAX:", p->ctx_RegEax, 8, outBuffer );
    pair( " EBX:", p->ctx_RegEbx, 8, outBuffer );
    pair( " ECX:", p->ctx_RegEcx, 8, outBuffer );
    pair( " EDX:", p->ctx_RegEdx, 8, outBuffer );
    pair( " EDI:", p->ctx_RegEdi, 8, outBuffer );
    pair( " ESI:", p->ctx_RegEsi, 8, outBuffer );
    strcat( outBuffer, "\r\n" );

    pair( "# FLAGS:", p->ctx_EFlags, 8, outBuffer );
    strcat( outBuffer, "\r\n# Env: " );

    for( int i=0; i<7; i++ )
      nultoa( (ULONG)p->ctx_env[i], outBuffer, " " );

    strcat( outBuffer, "\r\n# FP Stack: " );

    for( i=0; i<8; i++ )
    {
      strcat( outBuffer, "" );
      nultoa( (ULONG)p->ctx_stack[i].hisig,   outBuffer, " " );
      nultoa( (ULONG)p->ctx_stack[i].losig,   outBuffer, " " );
      nultoa( (ULONG)p->ctx_stack[i].signexp, outBuffer, " ", 4 );

      if( i!=7 )
        strcat( outBuffer, "\r\n            " );
    }

    PULONG top( (PULONG)tib->tib_pstack      ),
           bot( (PULONG)tib->tib_pstacklimit );
    char first( 1 );
    int count( 0 );
 
    for( PULONG sp = (PULONG)p->ctx_RegEbp;
         sp<=bot && sp>=top && count<1000000;
         count++ )
    {
      if( first )
      {
        strcat( outBuffer, "\r\n# Called from " );
        first = 0;
      }
      else
        strcat( outBuffer, "              " );

      address( (ULONG)sp[1], outBuffer );
      strcat( outBuffer, " L" );
      decimal( (ULONG)count+2, outBuffer );
      strcat( outBuffer, "\r\n" );
      sp = (PULONG)sp[0];
    }
  }

  writeDump( outBuffer, taskNumber );

  if( !rc )
    DosFreeMem( &outBuffer );

  return 0;
}
