#include <string.h>

#include "newstr.h"
#include "calls.h"

Calls::Calls( char *f, char *p ) :
  flag( newStr( f ) ),
  pref( newStr( p ) )
{}

Calls::~Calls()
{
  delete flag;
  delete pref;
}

int Calls::equal( const BaseObject &t ) const
{
  return !stricmp( flag, ((const Calls*)&t)->flag );
}

char *Calls::nameOfClass() const
{
  return "Calls";
}

void Calls::print( ostream& s ) const
{
  s << flag << char(':') << (pref==NULL ? "<NULL>" : pref);
}

CallsList::CallsList() :
  Collection( 10, 5, SemaphoreModeNoNeed )
{
}
  
Calls* CallsList::Find( Calls& item, LockMode lock ) const
{
  return (Calls*)Collection::Find( item, lock );
}
    
Calls& CallsList::operator [] ( const int pos ) const
{
  return *(Calls*)&(Collection::operator[]( pos ));
}

CallsIterator::CallsIterator( CallsList& ini ) :
  CollectionIterator( *(Collection*)&ini )
{
}
  
Calls& CallsIterator::operator () () const
{
  return *(Calls*)&(CollectionIterator::operator()());
}
