//--------------------------------------
//
// Copyright (c) 1991 by Bad Data, INC.
// All rights reserved.
//
// Written by John Gladkih.
//
// Class cursor - implimentation.
//

#define INCL_VIO
#include <os2.h>

#include <string.h>

#include "cursor.h"

Cursor::Cursor( int det, int )
{
  state = 1;
  detachedSession = det;
  info = 0;
  newInfo = 0;

  if( !detachedSession )
  {
    info = (void *) new VIOCURSORINFO;
    
    VioGetCurPos( &y, &x, 0 );
    VioGetCurType( (PVIOCURSORINFO)info, 0 );
  }
}

Cursor::~Cursor()
{
  if( !detachedSession )
  {
    VioSetCurPos( y, x, 0 );
    VioSetCurType( (PVIOCURSORINFO)(newInfo ? newInfo : info), 0 );
    delete info;
    delete newInfo;
  }
}

Cursor& Cursor::operator+()
{
  state = 1;

  if( !detachedSession )
  {
    VIOCURSORINFO cinfo;
    
    memcpy( &cinfo, newInfo ? newInfo : info, sizeof cinfo );
    cinfo.attr = 0;

    VioSetCurType( &cinfo, 0 );
  }

  return *this;
}

Cursor& Cursor::operator-()
{
  state = 0;

  if( !detachedSession )
  {
    VIOCURSORINFO cinfo;
    
    memcpy( &cinfo, newInfo ? newInfo : info, sizeof cinfo );
    cinfo.cx = 0;
    cinfo.yStart = cinfo.cEnd = 0;
    cinfo.attr = 0xffff;

    VioSetCurType( &cinfo, 0 );
  }

 return *this;
}

void Cursor::newForm()
{
  if( !detachedSession )
  {
    delete newInfo;
    newInfo = (void *) new VIOCURSORINFO;
    
    VioGetCurType( (PVIOCURSORINFO)newInfo, 0 );
  }
}