#define INCL_DOS
#define INCL_DOSDATETIME
#define INCL_DOSPROCESS
#include <os2.h>

#include <string.h>

void returnSystemScreen();
long getTaskNumber();
void abortAndExit();
void keyCtrlCFound( void );

extern char detachedSession;

extern volatile char systemIsReady;
extern const char *M_NAME;
extern       char *M_NUMBER;
extern const char *M_VERSION;

APIRET (* APIENTRY displayContext)( PCONTEXTRECORD p, PEXCEPTIONREPORTRECORD p1,
                                    int taskNumber,
                                    const char *M_NAME,
                                    char *M_NUMBER,
                                    const char *M_VERSION ) = 0;

HMODULE initTrace()
{
  char errBuf[80] = {0};
  HMODULE hTrace;
  APIRET rc = DosLoadModule( errBuf, sizeof(errBuf), "BrakeTrc", &hTrace );

  if( rc )
    return 0;

  rc = DosQueryProcAddr( hTrace, 1, 0, (PFN *)&displayContext );

  if( rc )
  {
    DosFreeModule( hTrace );
    return 0;
  }

  return hTrace;
}

APIRET APIENTRY ShutDownHandler( PEXCEPTIONREPORTRECORD       p1,
                                 PEXCEPTIONREGISTRATIONRECORD,
                                 PCONTEXTRECORD               p3,
                                 PVOID )
{
  HMODULE hTrc( 0 );

  switch( (unsigned int)p1->ExceptionNum )
  {
  case XCPT_ACCESS_VIOLATION:
  case XCPT_INTEGER_DIVIDE_BY_ZERO:
  case XCPT_ILLEGAL_INSTRUCTION:
  case XCPT_PRIVILEGED_INSTRUCTION:
  case XCPT_INTEGER_OVERFLOW:
  case XCPT_FLOAT_DIVIDE_BY_ZERO:
  case XCPT_FLOAT_INVALID_OPERATION:
  case XCPT_FLOAT_OVERFLOW:
  case XCPT_FLOAT_UNDERFLOW:
  case XCPT_FLOAT_DENORMAL_OPERAND:
  case XCPT_FLOAT_INEXACT_RESULT:
  case XCPT_FLOAT_STACK_CHECK:
  case XCPT_DATATYPE_MISALIGNMENT:
  case XCPT_UNABLE_TO_GROW_STACK:
  case XCPT_IN_PAGE_ERROR:
  case XCPT_NONCONTINUABLE_EXCEPTION:
  case XCPT_INVALID_DISPOSITION:
  case XCPT_INVALID_LOCK_SEQUENCE:
  case XCPT_ARRAY_BOUNDS_EXCEEDED:
  case XCPT_B1NPX_ERRATA_02:
  case XCPT_BAD_STACK:
  case XCPT_BREAKPOINT:
  case XCPT_SINGLE_STEP:
//  case XCPT_UNWIND:
//  case XCPT_INVALID_UNWIND_TARGET:
//  case XCPT_GUARD_PAGE_VIOLATION:
//  case XCPT_PROCESS_TERMINATE:
//  case XCPT_ASYNC_PROCESS_TERMINATE:

    hTrc = initTrace();

    if( hTrc )
    {
      displayContext( p3, p1, (int)getTaskNumber(), M_NAME, M_NUMBER, M_VERSION );
      DosFreeModule( hTrc );

      if( systemIsReady )
      {
        systemIsReady = 0;
        returnSystemScreen();
      }

      DosExit( EXIT_PROCESS, 1 );
    }
    break;

  case XCPT_SIGNAL:
    switch( p1->ExceptionInfo[0] )
    {
    case XCPT_SIGNAL_INTR:
    case XCPT_SIGNAL_BREAK:
      if( !detachedSession )
      {
        keyCtrlCFound();
        return (APIRET)XCPT_CONTINUE_EXECUTION;
      }

// fall

    case XCPT_SIGNAL_KILLPROC:
      extern char detectKillProcess;

      if( detectKillProcess )
      {
        abortAndExit();
        return (APIRET)XCPT_CONTINUE_EXECUTION;
      }
    }
  }

  return XCPT_CONTINUE_SEARCH;
}

