#ifndef _GLOBALVARS_H

#define _GLOBALVARS_H

#include "class.h"

class GlobalVariable : public BaseObject
{
  char *name,
       *value;

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

public:
  GlobalVariable( char *_name, char *_value );
  ~GlobalVariable();

  int less( const GlobalVariable &t ) const;

  char *getName() const { return name; }
  char *getValue() const;
  void setValue( char *_value );
};

class GlobalVariableList : public Collection			//GlobalVariable
{
public:
  GlobalVariableList();

  GlobalVariable* Find( GlobalVariable& item, LockMode lock=LockModeNeed ) const;
  GlobalVariable& operator [] ( const int pos ) const;

  void sort();
};

class GlobalVariableIterator : public CollectionIterator	//GlobalVariable
{
public:
  GlobalVariableIterator( GlobalVariableList& ini );

  GlobalVariable& operator () () const;
};

#endif