#define INCL_DOSMEMMGR
#define INCL_DOSPROCESS
#include <os2.h>

#include <stdlib.h>
#include <stdio.h>
#include <process.h>

#include "language.h"

#include "misc.h"
#include "key.h"
#include "timer.h"

void help( char *s, int fl )
{
  int lines( 0 ),
      maxWidth( 0 ),
      width( 0 ),
      done( 0 );
  register char *p( s );

  keyClear();

  while( !done )
    switch( *(p++) )
    {
    case 1:
    case 2:
      break;

    case 0:
      if( width )
      {
        lines++;

        if( width>maxWidth )
          maxWidth = width;
      }

      done = 1;
      break;

    case '\n':
      lines++;

      if( width>maxWidth )
        maxWidth = width;

      width = 0;

      break;

    default:
      width++;

    }

  if( maxWidth<31 )
    maxWidth = 31;

  lines += 7;
  maxWidth += 4;

  if( lines>22 )
    lines = 22;

  if( lines<8 )
    lines = 8;

  if( maxWidth>76 )
    maxWidth = 76;

  Color hlpColor( colorSet.help ),
	hlpBold( colorSet.helpBold );

  Window hlp( ((Z_ScreenWidth-maxWidth)>>1)+1, ((Z_ScreenHeight-lines)>>1)+1,
	      maxWidth, lines,
	      hlpColor,
	      Msg_ScrHelpTitle,
	      BS_DOUBLELINE,
	      DS_LOWERRIGHT );

  hlp.setScroll( 0 );
  hlp( 2, 2 );

  for( p=s; *p; p++ )
    switch( *p )
    {
    case 1:
      hlp = hlpBold;
      break;

    case 2:
      hlp = hlpColor;
      break;

    case '\n':
      hlp << char('\r');
      hlp << char('\n');
      hlp << char(' ');
      break;

    default:
      hlp << *p;
    }

  char b[80];
  void *pp;

  DosAllocMem( &pp, 10, PAG_COMMIT|PAG_READ|PAG_WRITE );
  DosFreeMem( pp );
  sprintf( b, Msg_ScrHelpStatOS, long(pp)/1024l );

  hlp.centre( lines-4, b );

  sprintf( b, Msg_ScrHelpCache,
	   nodeList.getCacheUsage(), nodeList.getCacheHints() );
  hlp.centre( lines-2, b );

  +hlp;

  char buf[64];

  int oldRest( -1 );
  Timer t( 60000l );

  while( !keyPressed() && !t.isTimeOut() )
  {
    if( oldRest!=t.secsLeft() )
    {
      oldRest = t.secsLeft();
      sprintf( buf, " %02d:%02d ", oldRest/60, oldRest%60 );

      Z_TextOver( hlp.getWindow(), buf, maxWidth-2-strlen(buf), lines-1 );
    }

    if( fl && comPort->haveInput() )
      break;

    checkPoint();
  }

  if( keyPressed() )
    keyGet();
}
