#define INCL_DOSSEMAPHORES
#define INCL_DOSQUEUES
#define INCL_DOSSESMGR
#define INCL_WIN
#define INCL_VIO
#define INCL_DOSPROCESS
#define INCL_WINSWITCHLIST
#define INCL_WINPROGRAMLIST
#define INCL_WINWORKPLACE
#define INCL_DOS
#define INCL_KBD
#include <os2.h>

#undef BS_NOBORDER

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <share.h>
#include <fcntl.h>
#include <signal.h>
#include <new.h>
#include <locale.h>

#include <stdlib.h>
#include <process.h>

#include "language.h"

#include "dinamic.h"
#include "register.h"
#include "misc.h"
#include "translat.h"
#include "queue.h"
#include "nodelist.h"
#include "zmodem.h"
#include "zinter.h"
#include "process.h"
#include "sched.h"
#include "enable.h"
#include "config.h"
#include "calls.h"
#include "rexx.h"
#include "rexxhook.h"
#include "key.h"
#include "vio.h"
#include "getopt.h"
#include "crc.h"
#include "timeout.h"
#include "hydra.h"
#include "addinqu.h"
#include "nolog.h"
#include "fax.h"
#include "freq.h"
#include "heap.h"

const int   M_CODE = 0x101;
char *M_COPYRIGHT = "Copyright (c) 1995-1999 by John Gladkih.";
char *M_NAME = "The Brake!(tm) Mailer";
char *M_NUMBER = "Unreg";
char *M_VERSION = BUILD_VERSION;

ResourceList mutexSemList,
             eventSemList,
             queueList;

Miscellenous miscInfo =
{
  1,								      //task number
  SysState( Collision|Full5D|ScanBefore|CallAfterAnswer ),	      //state
  SysState1( DiscardPKT|RetryAfterExtern|StatusLine|NotAcceptAbort ), //state1
  SysState2( TaskInLog|HydraAvail|ZedZapAvail ),                      //state2
  SysState3( CheckREQ ),	 				      //state3
  60, 30,		// circle max, min
  600,			// rescan
  1000,                 // rescanPeriod
  0,			// port
  9600,			// baud
  newStr( ".\\inbound\\" ),	// inbound
  NULL,      		// protected inbound
  NULL,			// tbox
  NULL,			// flags
  NULL,       		// zmh
  NULL,			// answer time
  NULL,			// call time
  NULL,       		// freqtime
  0,			// redial
  60,			// timeout
  120000l,		// emsi
  0,			// zblock
  NULL,			// emsilog
  newStr( "Brake!.Log" ),
  3,
  3,
  5,
  0, 0, 0, 0,
  newStr( "Brake!.Sch" ),
  newStr( "Brake!.Scc" ),
  0,
  0,
  3600,
  0, 0,         // session limit
  0, 0,         // day limit
  0, 0,         // week limit
  0, 0,         // mon limit
  newStr( "Brake!.Frq" ),
  0,            // minFreqBaud
  NULL,         // freqPolicy
  0,            // split size
  600,          // split circle
  2,            // priority class
  0,            // priority delta
  0,            // empty exit
  NULL,         // BBSTime
  0,            // minBBSBaud
  0, 0,         // maxIn, maxOut
  0,            // maxTry
  4096,         // logBuffer
  3*60*60,      // bsyAge,
  0,            // bsyInterval;
  NoFreq,
  NULL,         // binLogName
  2,            // rescan priority class
  0,            // rescan priority delta
  NULL,         // pipe path
  newStr( "\\SEM32\\Brake!\\User\\"),   	// semaphore
  newStr( ".\\Rexx\\" ),			// rexx path
  newStr( "\\Sem32\\Brake!\\Busy\\" ),   	// bsySemaPath;
  NULL,				// longBox
  NULL,				// exclude
  0,				// maxRRing;
  1, 				// ringCount;
  5,				// ringWait
  5,				// checkFlags
  5,				// checkSched
  NULL,				// remoteName;
  0,				// remotePassword;
  NULL,				// exitFlag
  0,				// maxcost
  0,				// terminalTimeOut
  0,				// volume
  newStr( ".\\Wave\\" ),	// wave path
  NULL,				// *noSound
  QueueSortAddr,		// sortMode
  0,				// autoInit
  NULL,				// terminalInbound
  NULL,				// sentList
  NULL,				// callOnlyImmed;
  NULL,				// callOnlyCrash;
  NULL,				// callOnlyDirect;
  NULL,				// callOnlyNormal;
  FileCaseMixed,		// fileCase;
  0,				// splitPktSize;
  0,				// separator;
  2,				// timeSyncDelta;
  NULL,				// iconMail,
  NULL,				// iconXMail,
  NULL,				// iconRIP;
  3600,				// holdTime;
  0,                            // inFileBufferSize
  0,				// outFileBufferSize
  newStr( "FreqBase.Idx" ),	// char *freqIdx;
  1,				// char enableMMPM;
  { '@', 'I' },			// char addrForm[2];
  10,				// int chatTimeout;
  500,				// long statusLine;
  NULL,				// char *longOutbound;
  NULL,				// char *saverModule;
  0,				// int saverInterval;
  1,				// unsigned long compilerPriority;
  0,				// long compilerPriorityDelta;
  0,				// long splitFileSize;
  5*60*1000,			// long configCheck
  2				// int sendTry;
};

ModemStrings modemString =
{
  newStr( "RING" ),
  newStr( "BUSY" ),
  newStr( "OK" ),
  newStr( "CONNECT" ),
  newStr( "NO DIAL" ),
  newStr( "RRING" ),
  newStr( "NO CARRIER" ),
  newStr( "ERROR" ),
  newStr( "VOICE" ),
  newStr( "NO ANSWER" ),
  newStr( "NO CONNECT" ),
  NULL,					//  char *statCmd,
  NULL,					//       *statStop;
  newStr( "Caller's ID: " ),
  newStr( "+FCO" )			// fax
};

InfoForBBS bbsInfo;

InfoForBBS::InfoForBBS()
{
  twiceEsc  = newStr( Msg_InfoHumanAllow );
  mailOnly  = newStr( Msg_InfoIsMO );
  slowModem = newStr( Msg_InfoIsSlowMdm );
  mailNow   = newStr( Msg_InfoIsTempMO );
  loading   = newStr( Msg_BBSLoading );
  goodBye   = newStr( Msg_BBSNoLoading );
}

char pszAppBrake[32] = "Brake! Mailer\0";

DefinePort portInfo =
{
  B9600,	// speed
  NULL,		// init
  NULL,		// answer
  NULL,		// hangup
  NULL,		// pref
  NULL,		// suff
  NULL,		// after
  NULL,		// dialterm
  NULL,		// ONeXIT
  60000l,	// failSafe
  0,		// callWait
  0,		// answerWait
  0, 		// pause
  1,		// blockMode
  0,		// carrierDelay
  1,		// hardwareFlow
  0,		// breakMode
  0     	// virtualDCD
};

FaxConfig faxConfig =
{
  NULL,
  0
};

OutboundInfo outboundInfo =
{
  newStr( ".\\NodeList" ),			// path
  newStr( ".\\" ), 				// root
  newStr( "Brake!.Idx" ),			// index
  new DomainList,				// domains
  NULL						// defDomain
};

Melodies melodies =
{
  NULL, 			//*connect,
  NULL, 			//*begSess,
  NULL, 			//*endSess,
  NULL, 			//*abort,
  NULL, 			//*human,
  NULL, 			//*error,
  NULL,	 			//*ring;
  NULL,				//*alarm
  NULL,			    	//*start
  NULL,			    	//*stop
  NULL,				//*bell
  NULL,				//*fail
  NULL				//*chat
};

char noPMFeatures = 0;
char isFullScreen = 0;

volatile int OSReturnCode = 0;

ColorSet colorSet = { 0, 0, 1 };

char *monthName[12] =
{
  "Jan", "Feb", "Mar", "Apr", "May", "Jun",
  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

FIDOAddress *defaultAddress = new FIDOAddress( "2:5051/16@fidonet" );

TranslationTable *translationTable( NULL );
Modem *comPort( NULL );

TimeOutList *timeOuts( NULL ),
            *zMinOutCps( NULL ),
            *zMinInCps( NULL );

TimeOutList *timeOutsHydra( NULL ),
            *hMinOutCps( NULL ),
            *hMinInCps( NULL );

HookList *rexxHookList( NULL );

ProcessList *processTable( NULL );
ProcessList *onlineTable( NULL );
ProcessList *immediateTable( NULL );

ModemStringList *ignoreString( NULL );
ModemStringList *badCounterString( NULL );

NoLogList *noLogList( NULL );
NoLogList *noScrList( NULL );


CallsList *preffixList( NULL );
CallsList *suffixList( NULL );

EnableList *enabledList( NULL ),
           *disabledList( NULL );

EnableList *acceptedList( NULL ),
           *unAcceptedList( NULL );

EnableList *timeSyncList( NULL );

Schedule *schedList( NULL );
int schedCount = 0;
int schedCurrent = 0;

Schedule *keyList( NULL );
int keyCount = 0;

Schedule *startUpList( NULL );
int startUpCount = 0;

Schedule *exitList( NULL );
int exitCount = 0;

Schedule *flagList( NULL );
int flagCount = 0;

Schedule *noFlagList( NULL );
int noFlagCount = 0;

Schedule *actionList( NULL );
int actionCount = 0;

Pair *connectList( NULL );
int connectCount;
int currentConnectItem;

Pair *handShakeList( NULL );
int handShakeCount;

Schedule *processBBS( NULL );

CfgFileList cfgFileList;

Color *stdColorPtr( NULL ),
      *brdColorPtr( NULL ),
      *scrColorPtr( NULL ),
      *popUpColorPtr( NULL ),
      *terColorPtr( NULL );

Cursor *screenCursorPtr( NULL );
Window *masterScreenPtr( NULL );

Window *wndModemPtr( NULL ),
       *wndModemFrame( NULL ),
       *wndLogPtr( NULL ),
       *wndStatPtr( NULL ),
       *wndQueuePtr( NULL ),
       *terminalWindowPtr( NULL ),
       *statusLineWindowPtr( NULL ),
       *headLineWindowPtr( NULL );

volatile long wndModemLast = 0;

NodeConfigList *systemList( NULL );
NodeConfigList *maskList( NULL );
Queue *queue( NULL );
LOG *logPtr( NULL );
Nodelist *nodeListPtr( NULL );

CallsList *arqList;
CallsList *halfDuplexList;
NoHydraChatList *noHydraChatList;

unsigned long      Queue::globalSemaphore = 0xffffffffl;
SharedQueueHeader *Queue::sharedQueueHeader = 0;
SharedMemory      *Queue::shMem = NULL;

AddInQueueList *addInQueueList = NULL;

Sleeper *sleeper;

SystemInfo systemInfo;

SystemInfo::SystemInfo()
{
  name = newStr( "Anonymous System" );
  sysopName = newStr( "Anonymous SysOp" );
  place = newStr( "Unknown city" );
  phone = newStr( "-Unpublished-" );
  baud = newStr( "300" );
  flags = newStr( "MO" );
  addr = new FIDOAddressList;
}

SystemInfo::~SystemInfo()
{
  delete addr;
}

volatile char systemIsReady = 0;

int onlineAnswer = 0;
int onlineAnswerBaud = 0;
int onlineHandle = -1;
FIDOAddress *callOneNode = NULL;
int telebitFuckinCorrectionTimes = 0;

Chatter *chatterPointer = 0;

void setBinaryKbdMode( void )
{
  KBDINFO ki;

  ki.cb = sizeof(ki);
  KbdGetStatus(&ki, 0);

  ki.fsMask &= ~KEYBOARD_ASCII_MODE;
  ki.fsMask |= KEYBOARD_BINARY_MODE;
  ki.cb = sizeof(ki);
  KbdSetStatus(&ki, 0);
}

static VIOMODEINFO savedVio;

/*
PVOID Thunk16To32Pointer( PVOID p )
{
  ULONG tmp;

  if( p )
  {
    tmp = (ULONG)HIUSHORT(p);
    tmp = (tmp >> 3) << 16;
    tmp = tmp + ((long)p & 0xFFFF);

    return (PVOID)tmp;
  }

  return NULL;
}
*/

int VioSystemScreen( int x, int y );

void setVideoMode( int x, int y )
{
  if( detachedSession )
  {
    Z_ScreenWidth = 80;
    Z_ScreenHeight = 25;
    VioSystemScreen( 80, 25 );
    return;
  }

  VIOMODEINFO vio;

  vio.cb = sizeof(vio);
  VioGetMode( &vio, 0 );

  memcpy( &savedVio, &vio, sizeof(vio) );

  if( x || y )
  {
    if( x )
      vio.col = (USHORT)x;

    if( y )
      vio.row = (USHORT)y;

    vio.cb = 8;
    VioSetMode( &vio, 0 );
    vio.cb = sizeof(vio);
    VioGetMode( &vio, 0 );
  }

  Z_ScreenWidth = vio.col;
  Z_ScreenHeight = vio.row;
  VioSystemScreen( Z_ScreenWidth, Z_ScreenHeight );
}

static char *savedScreen = NULL;
USHORT scrLength = 0;

void saveScreen()
{
  VIOMODEINFO vio;

  vio.cb = sizeof(vio);
  VioGetMode( &vio, 0 );
  scrLength = (USHORT)vio.full_length;
  savedScreen = new char [ scrLength ];
  VioReadCellStr( savedScreen, &scrLength, 0, 0, 0 );
  VioSystemScreen( vio.col, vio.row );
}

void restoreScreen()
{
  if( savedScreen!=NULL )
    VioWrtCellStr( savedScreen, scrLength, 0, 0, 0 );
}

inline void putHeader( char *msg, int col, int row )
{
  (masterScreen( col+1, row ) = brdColor) << char(0x20) << msg
		    << char( 0x20 ) = stdColor ;
}

static TID statusTh=0xffffffffl;
volatile char statusAbort = 0;

static volatile long queueMonitor = -1;

char startInputQueueMonitor = 0;

static volatile TID bsyTID = 0xffffffffl;
static volatile TID flagsTID = 0xffffffffl;
static volatile TID schedTID = 0xffffffffl;

char detachedSession = 0;
int daemonMode = -1;

void checkDetach()
{
  if( daemonMode != -1 )
    detachedSession = 1;
  else
  {
    PTIB tib;
    PPIB pib;

    DosGetInfoBlocks( &tib, &pib );
    detachedSession = char(UCHAR(pib->pib_ultype)==4 ? 1 : 0);
  }
}

int makeColor( int cl, int mn )
{ 
  return colorSet.isColor ? cl : mn;
}

unsigned long volatile systemStartTime  = 0;
unsigned long volatile systemUsageTime  = 0;
unsigned long volatile systemUsageBegin = 0;

long nodeListCacheSize = 150;
long sharedMemoryQueueSize = 60;

char *switchListTitle = NULL;
void *winTitleObject = NULL;

//static HSWITCH MyHandle = NULLHANDLE;
//static SWCNTRL MyTaskInfo;

HAB  (* APIENTRY BrakeWinQueryAnchorBlock)( HWND hwnd ) = 0;
BOOL (* APIENTRY BrakePrfCloseProfile)( HINI hini ) = 0;
HINI (* APIENTRY BrakePrfOpenProfile)( HAB hab, PCSZ pszFileName ) = 0;
BOOL (* APIENTRY BrakePrfWriteProfileString)( HINI hini,
                                              PCSZ pszApp,
                                              PCSZ pszKey,
                                              PCSZ pszData ) = 0;
BOOL (* APIENTRY BrakePrfWriteProfileData)( HINI hini,
                                            PCSZ  pszApp,
                                            PCSZ  pszKey,
                                            PVOID pData,
                                            ULONG cchDataLen ) = 0;
ULONG (* APIENTRY BrakePrfQueryProfileString)( HINI hini,
                                               PCSZ  pszApp,
                                               PCSZ  pszKey,
                                               PCSZ  pszDefault,
                                               PVOID pBuffer,
                                               ULONG cchBufferMax ) = 0;
BOOL (* APIENTRY BrakePrfQueryProfileData)( HINI hini,
                                            PCSZ  pszApp,
                                            PCSZ  pszKey,
                                            PVOID pBuffer,
                                            PULONG pulBuffLen ) = 0;
BOOL (* APIENTRY BrakeOpenObject)( char *obj ) = 0;

void * (* APIENTRY BrakeInitTitle)() = 0;
void (* APIENTRY BrakeDeInitTitle)( void * ) = 0;

void (* APIENTRY BrakeSwitchToForeground)( void * ) = 0;
void (* APIENTRY BrakeSetTitle)( void *, char * ) = 0;
void (* APIENTRY BrakeSetIcon)( void * ) = 0;
void (* APIENTRY BrakeSetFrame)( void *, int, int, int, int ) = 0;

int (* APIENTRY BrakeWinMessage)( char *title, char *message ) = 0;
char *(* APIENTRY BrakeGetFromClipboard)() = 0;

static HMODULE BrakePmModule = 0;

void deInitPMFeatures()
{
  if( noPMFeatures || detachedSession )
    return;

  BrakeDeInitTitle( winTitleObject );
  winTitleObject = 0;

  if( BrakePmModule )
    DosFreeModule( BrakePmModule );
}

int initPMFeatures()
{
  if( noPMFeatures || detachedSession )
    return 0;

  char buf[80];
  char *dll = "BrakePm";
  APIRET rc = DosLoadModule( buf, sizeof(buf), dll, &BrakePmModule );

  if( rc )
  {
    log( Msg_ErrDllNotLoaded, dll, rc );
    os2Message( rc );
    return 1;
  }
  else
  {
    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeSetFrame",
                           (PFN *)&BrakeSetFrame );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeSetFrame", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeSetTitle",
                           (PFN *)&BrakeSetTitle );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeSetTitle", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeSetIcon",
                           (PFN *)&BrakeSetIcon );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeSetIcon", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeInitTitle",
                           (PFN *)&BrakeInitTitle );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeInitTitle", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeDeInitTitle",
                           (PFN *)&BrakeDeInitTitle );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeDeInitTitle", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakePrfCloseProfile",
                           (PFN *)&BrakePrfCloseProfile );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakePrfCloseProfile", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakePrfOpenProfile",
                           (PFN *)&BrakePrfOpenProfile );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakePrfOpenProfile", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakePrfWriteProfileString",
                           (PFN *)&BrakePrfWriteProfileString );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakePrfWriteProfileString", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakePrfWriteProfileData",
                           (PFN *)&BrakePrfWriteProfileData );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakePrfWriteProfileData", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakePrfQueryProfileString",
                           (PFN *)&BrakePrfQueryProfileString );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakePrfQueryProfileString", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakePrfQueryProfileData",
                           (PFN *)&BrakePrfQueryProfileData );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakePrfQueryProfileData", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeWinQueryAnchorBlock",
                           (PFN *)&BrakeWinQueryAnchorBlock );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeWinQueryAnchorBlock", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeOpenObject",
                           (PFN *)&BrakeOpenObject );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeOpenObject", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeWinMessage",
                           (PFN *)&BrakeWinMessage );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeWinMessage", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeGetFromClipboard",
                           (PFN *)&BrakeGetFromClipboard );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeGetFromClipboard", dll );
      os2Message( rc );
      return 1;
    }

    rc = DosQueryProcAddr( BrakePmModule, 0, "BrakeSwitchToForeground",
                           (PFN *)&BrakeSwitchToForeground );

    if( rc )
    {
      log( Msg_UnableFindProc, "BrakeSwitchToForeground", dll );
      os2Message( rc );
      return 1;
    }
  }

  winTitleObject = BrakeInitTitle();
  return 0;
}

int pmMessage( char *title, char *msg )
{
  if( noPMFeatures || detachedSession || !BrakeWinMessage )
    return 0;

  return BrakeWinMessage( title, msg );
}

void openObject( char *obj )
{
  if( noPMFeatures || detachedSession || !BrakeOpenObject )
    return;

  int rc( (int)BrakeOpenObject( obj ) );

  switch( rc )
  {
  case 0:
    break;

  case 1:
    log( Msg_ErrUnableObjFind, obj );
    break;

  case 2:
    log( Msg_ErrUnableObjOpen, obj );
    break;

  default:
    log( "*BUG* OpenObject '%s' illegal rc=%d", obj, rc );
    break;
  }
}

void changeTitleAndSwitch( char *str  )
{
  if( noPMFeatures || detachedSession || !winTitleObject || !BrakeSetTitle )
    return;

  BrakeSetTitle( winTitleObject, str );
}

void changeIcon()
{
  if( noPMFeatures || detachedSession || !winTitleObject || !BrakeSetIcon )
    return;

  BrakeSetIcon( winTitleObject );
}

char *titleMode = NULL;
static char separ[]=", ";

void addTitleMode( char *mode )
{
  if( noPMFeatures || detachedSession )
    return;

  if( mode==NULL )
    return;

  char *str;

  if( titleMode == NULL )
    str = newStr( mode );
  else
  {
    str = new char [ strlen(titleMode)+strlen(mode)+sizeof(separ) ];
    strcpy( str, titleMode );
    strcat( str, separ );
    strcat( str, mode );
  }

  delete titleMode;
  titleMode = str;
}

void setTitleMode( char *mode )
{
  if( noPMFeatures || detachedSession )
    return;

  delete titleMode;
  titleMode = newStr( mode );
}

void changeTitle( char *ttl )
{
  if( noPMFeatures || detachedSession )
    return;

  int len = strlen(switchListTitle)+1;

  if( ttl!=NULL )
    len += strlen( ttl ) + sizeof( separ )-1;

  if( titleMode!=NULL )
    len += strlen( titleMode ) + sizeof( separ )-1;

  char *str = new char [ len ];

  strcpy( str, switchListTitle );

  if( titleMode!=NULL )
  {
    strcat( str, separ );
    strcat( str, titleMode );
  }

  if( ttl!=NULL )
  {
    strcat( str, separ );
    strcat( str, ttl );
  }

  changeTitleAndSwitch( str );
//  changeIcon();			//hack! :(

  delete str;
}

void _Optlink bonus( void * )
{
  DosSetPriority( PRTYS_THREAD, PRTYC_TIMECRITICAL, PRTYD_MAXIMUM, 0 );

  Color clColor( makeColor( WHITE, BLACK ), makeColor( RED, WHITE ) );
  Window w( (Z_ScreenWidth-60)/2+1, (Z_ScreenHeight-9)/2+1,
            60, 9,
            clColor,
            " Hello! ", BS_DOUBLELINE, DS_LOWERRIGHT );
  char buf[128];

  strcpy( buf, M_COPYRIGHT );
  w.centre( 4, buf );
  sprintf( buf, "%s Version %s, serial #%s", M_NAME, M_VERSION, M_NUMBER );
  w.centre( 2, buf );
  w.centre( 6, "Not for LAME users only ;)" );
  +w;

  WINDOW *pWin = w.getWindow();
  int delta = (w.getWidth()-strlen(buf))/2+1;

  for( int i(0); buf[i]; i++ )
  {
    char s[3];

    s[0] = buf[i];
    s[1] = buf[i+1];
    s[2] = 0;

    Z_TextOut( pWin, s, i+delta, 2, BRIGHTWHITE, clColor.back );

    if( i )
      Z_CharOut( pWin, buf[i-1], i+delta-1, 2, clColor.fore, clColor.back );

    sleep( 250 );
  }

  Z_CharOut( pWin, buf[i-1], i+delta-1, 2, clColor.fore, clColor.back );
  sleep( 2000 );
}

void showHeadLine()
{
  char address[65];

  defaultAddress->toString( address, 65, FIDOAddressShowModeEMSI );

  if( (miscInfo.state1&StatusLine)==StatusLine )
  {
    headLineWindow( 1, 1 ).clearLine();
    headLineWindow( 2, 1 ) << address << "  "
                           << M_NAME << char(' ')
                           << M_VERSION << char('/')
                           << M_NUMBER;
  }
}

static char needBonus = 1;

int dataInit()
{
  DosSetPriority( PRTYS_PROCESS, miscInfo.priority, miscInfo.priorityDelta, 0 );

  PTIB tib;
  PPIB pib;

  DosGetInfoBlocks( &tib, &pib );

  if( !noPMFeatures && !detachedSession &&
      miscInfo.x && miscInfo.y && miscInfo.cx && miscInfo.cy )
    BrakeSetFrame( winTitleObject, 
                   miscInfo.x, miscInfo.y, miscInfo.cx, miscInfo.cy );

  if( switchListTitle==NULL )
    switchListTitle = newStr( systemInfo.name );

  if( switchListTitle==NULL )
  {
    switchListTitle = new char [ strlen(M_NAME)+strlen(M_VERSION)+
                                 strlen(M_NUMBER)+3 ];

    strcpy( switchListTitle, M_NAME );
    strcat( switchListTitle, " " );
    strcat( switchListTitle, M_VERSION );
    strcat( switchListTitle, "/" );
    strcat( switchListTitle, M_NUMBER );
  }

  if( !detachedSession && !noPMFeatures )
  {
    changeTitle( NULL );
    changeIcon();
  }

  if( miscInfo.port )
    comPort = new Modem( short( miscInfo.port-1 ),
                         portInfo.speed,
                         portInfo.init,
                         portInfo.hangup,
                         portInfo.answer,
	  	         portInfo.pref,
                         portInfo.suff,
                         portInfo.after,
                         portInfo.dialterm,
                         short( portInfo.callWait ),
                         short( portInfo.answerWait ),
                         short( portInfo.pause ),
		         portInfo.failSafe*1000l,
		         portInfo.blockMode,
                         long( portInfo.carrierDelay )*1000,
                         char( portInfo.hardwareFlow ),
		         char( portInfo.breakMode ),
                         onlineHandle,
                         portInfo.onExit,
                         char( portInfo.virtualDCD ) );
  else
    comPort = new FictionModem;

  Window::setLockMode( 0 );

  screenCursorPtr = new Cursor( (int)detachedSession, 0 );

  if( !detachedSession )
  {
    saveScreen();
    setVideoMode( colorSet.x, colorSet.y );
    screenCursor.newForm();
    -screenCursor;

    if( !colorSet.status  )
      colorSet.status = Color( BLACK, WHITE );

    if( !colorSet.statusLampOn  )
      colorSet.statusLampOn = Color( makeColor( BRIGHTWHITE, WHITE ),
				   makeColor( RED, BLACK ) );

    if( !colorSet.statusLampOff  )
      colorSet.statusLampOff = Color( BLACK, makeColor( BRIGHTWHITE, WHITE ) );

    if( !colorSet.border  )
      colorSet.border = Color( makeColor( BRIGHTWHITE, WHITE ),
			     makeColor( BLUE, BLACK ) );

    if( !colorSet.action  )
      colorSet.action = Color( makeColor( LT_CYAN, WHITE ),
			     makeColor( BLUE, BLACK ) );

    if( !colorSet.actionBold  )
      colorSet.actionBold = Color( BRIGHTWHITE, makeColor(BLUE, BLACK) );

    if( !colorSet.abort  )
      colorSet.abort = Color( makeColor( YELLOW, BLACK ),
			    makeColor( MAGENTA, WHITE ) );

    if( !colorSet.popUp  )
      colorSet.popUp = Color( makeColor( BRIGHTWHITE, BLACK ),
			    makeColor( CYAN, WHITE ) );

    if( !colorSet.popUpItem  )
      colorSet.popUpItem = Color( WHITE, makeColor( BLUE, BLACK ) );

    if( !colorSet.popUpBold  )
      colorSet.popUpBold = Color( makeColor( YELLOW, BRIGHTWHITE ),
				makeColor( BLUE, BLACK ) );

    if( !colorSet.terminal  )
      colorSet.terminal = Color( WHITE, BLACK );

    if( !colorSet.help  )
      colorSet.help = Color( makeColor( LT_CYAN, BLACK ),
			   makeColor( BLUE, WHITE ) );

    if( !colorSet.helpBold  )
      colorSet.helpBold = Color( makeColor( BRIGHTWHITE, WHITE ),
			       makeColor( BLUE, BLACK ) );

    int ccc( Color( colorSet.action ).back );

    if( !colorSet.queueImmed )
      colorSet.queueImmed = Color( makeColor( YELLOW, Color( colorSet.action ).fore ),
                                   ccc );

    if( !colorSet.queueCrash )
      colorSet.queueCrash = Color( makeColor( LT_CYAN, Color( colorSet.action ).fore ),
                                   ccc );

    if( !colorSet.queueDirect )
      colorSet.queueDirect = Color( makeColor( BRIGHTWHITE, Color( colorSet.action ).fore ),
                                    ccc );

    if( !colorSet.queueNormal )
      colorSet.queueNormal = Color( makeColor( WHITE, Color( colorSet.action ).fore ),
                                    ccc );

    if( !colorSet.queueHold )
      colorSet.queueHold = Color( makeColor( DARKGRAY, Color( colorSet.action ).fore ),
                                  ccc );

    if( !colorSet.queuePtr )
      colorSet.queuePtr = Color( BRIGHTWHITE,
			         makeColor( BLUE, BLACK ) );

    if( !colorSet.modemTo )
      colorSet.modemTo = Color( makeColor( BLACK, BRIGHTWHITE ),
			        makeColor( Color( colorSet.popUp ).back, BLACK ) );

    if( !colorSet.modemCtlTo )
      colorSet.modemCtlTo = Color( makeColor( BLUE, BLACK ),
                                   makeColor( Color( colorSet.popUp ).back, WHITE ) );
    if( !colorSet.modemFrom )
      colorSet.modemFrom = Color( makeColor( BRIGHTWHITE, WHITE ),
			          makeColor( Color( colorSet.popUp ).back, BLACK ) );
    if( !colorSet.modemCtlFrom )
      colorSet.modemCtlFrom = Color( makeColor( LT_BLUE, DARKGREY ),
                                     makeColor( Color( colorSet.popUp ).back, WHITE ) );
  }

  stdColorPtr   = new Color( colorSet.action );
  brdColorPtr   = new Color( colorSet.border );
  popUpColorPtr = new Color( colorSet.popUp );
  scrColorPtr   = new Color( colorSet.status );
  terColorPtr   = new Color( colorSet.terminal );

  int statusDelta = (miscInfo.state1&StatusLine)==StatusLine ? 0 : 1;

  chatterPointer = new Chatter;

  masterScreenPtr = new Window( 1, 1, Z_ScreenWidth, Z_ScreenHeight, scrColor );
  masterScreen.setScroll( 0 );

  if( !statusDelta )
  {
    statusLineWindowPtr = new Window( 1, Z_ScreenHeight, Z_ScreenWidth,
                                      1, scrColor );
    statusLineWindow.setScroll( 0 );
    headLineWindowPtr = new Window( 1, 1, Z_ScreenWidth, 1, scrColor );
    headLineWindow.setScroll( 0 );
  }

  Color scrCl = Color( terColor.fore, terColor.back );
  terminalWindowPtr = new Window( 1, 1,
                                  Z_ScreenWidth, Z_ScreenHeight-1+statusDelta,
				  scrCl );
  wndLogPtr       = new Window( 2, 3-statusDelta, Z_ScreenWidth-28, 9, stdColor );
  wndStatPtr      = new Window( Z_ScreenWidth-25, 3-statusDelta, 25, 9, stdColor );
  wndQueuePtr     = new Window( 2, 13-statusDelta,
                                Z_ScreenWidth-2, Z_ScreenHeight-14+statusDelta+statusDelta,
				stdColor );

  if( (miscInfo.state&ModemWindow)==ModemWindow  )
  {
    wndModemFrame   = new Window( miscInfo.wndModemX, miscInfo.wndModemY,
				  30, 14, popUpColor,
				  Msg_WndTitleMdm, BS_SINGLELINE, DS_LOWERRIGHT );
    wndModemPtr     = new Window( miscInfo.wndModemX+1, miscInfo.wndModemY+1,
				  28, 12, popUpColor );
  }

  logPtr = new LOG( miscInfo.logName );

  if( !detachedSession )
  {
    int i;

    masterScreen = stdColor;

    for( i=3-statusDelta; i<Z_ScreenHeight-1+statusDelta; i ++ )
      masterScreen( 2, i ).clearLine();

    masterScreen( 2, 2-statusDelta );
    for( i = 0; i<Z_ScreenWidth-2; i++ )
      masterScreen << char('');

    masterScreen( 2, Z_ScreenHeight-1+statusDelta );
    for( i=0; i<Z_ScreenWidth-2; i++ )
      masterScreen << char('');

    for( i=2-statusDelta; i<Z_ScreenHeight-1+statusDelta; i++ )
      masterScreen( Z_ScreenWidth, i ) << "";

    for( i=3-statusDelta; i<12; i++ )
      masterScreen( Z_ScreenWidth-26, i ) << char('');

    masterScreen( 2, 12-statusDelta );
    for( i=0; i<Z_ScreenWidth-2; i++ )
      masterScreen << char('');

    masterScreen( 1, Z_ScreenHeight-1+statusDelta ) << char('');
    masterScreen( Z_ScreenWidth, Z_ScreenHeight-1+statusDelta ) << char('');
    masterScreen( 1, 2-statusDelta ) << char( '' );
    masterScreen( Z_ScreenWidth, 2-statusDelta ) << char( '' );
    masterScreen( Z_ScreenWidth-26, 2-statusDelta ) << char( '');
    masterScreen( Z_ScreenWidth, 12-statusDelta ) << char( '');
    masterScreen( 1, 12-statusDelta ) << char( '');
    masterScreen( Z_ScreenWidth-26, 12-statusDelta ) << char( '');

    char buf[32];

    sprintf( buf, "%d", miscInfo.taskNumber );
    putHeader( Msg_WndTitleLog, 3, 2-statusDelta );
    putHeader( Msg_WndTitleAct, Z_ScreenWidth-24, 2-statusDelta );
    putHeader( buf, Z_ScreenWidth-31-strlen( buf ), 2-statusDelta );

    char *queueSortWord;

    switch( miscInfo.sortMode )
    {
    case QueueSortNoSort:
      queueSortWord = Msg_ScrQueueSortByNoSort;
      break;

    case QueueSortSizeDec:
      queueSortWord = Msg_ScrQueueSortBySizeDec;
      break;

    case QueueSortSize:
      queueSortWord = Msg_ScrQueueSortBySize;
      break;

    case QueueSortPriorityDec:
      queueSortWord = Msg_ScrQueueSortByPriorityDec;
      break;

    case QueueSortPriority:
      queueSortWord = Msg_ScrQueueSortByPriority;
      break;

    case QueueSortAgeDec:
      queueSortWord = Msg_ScrQueueSortByAgeDec;
      break;

    case QueueSortAge:
      queueSortWord = Msg_ScrQueueSortByAge;
      break;

    case QueueSortAddrDec:
      queueSortWord = Msg_ScrQueueSortByAddrDec;
      break;

    default:
      queueSortWord = Msg_ScrQueueSortByAddr;
      break;
    }

    putHeader( queueSortWord, Z_ScreenWidth-5-strlen( queueSortWord ),
               12-statusDelta );

    masterScreen = stdColor;

    wndQueue.setScroll( 0 );

    queue->draw();

    wndStat( 2, 2 ) << Msg_ScrAction;

    showAction( Msg_ScrSysInit );

    showHeadLine();
  }

  +masterScreen;

  if( (miscInfo.state1&StatusLine)==StatusLine )
  {
    +statusLineWindow;
    +headLineWindow;
  }

  +wndLog;
  +wndStat;
  +wndQueue;

  srand( (unsigned int)time( NULL ) );

  Window::setLockMode( 1 );
  systemIsReady = 1;

  {
    ULONG b[26];

    DosQuerySysInfo( 1, 26, b, sizeof(b) );

    char *tt( strTime( b[QSV_MS_COUNT-1]/1000, 0 ) );

    log( Msg_InfoOS, b[QSV_VERSION_MAJOR-1], b[QSV_VERSION_MINOR-1],
                     b[QSV_VERSION_REVISION-1], char(b[QSV_BOOT_DRIVE-1]+'A'-1) );
    if( b[26-1] )
      log( Msg_InfoOS1, tt, b[QSV_TOTPHYSMEM-1], b[26-1] );
    else
      log( Msg_InfoOS2, tt, b[QSV_TOTPHYSMEM-1] );

    delete tt;
  }

  if( comPort->initialize() )
    return 1;

  if( !comPort->getHardWareMode() )
    hydra_options |= hydraGetFlags( "XON" );

  if( !detachedSession && !onlineAnswer && needBonus )
    _beginthread( bonus, 0, 40960, 0 );

  void initBeepProcess();
  initBeepProcess();

  ClipConsoleInitialize( 1 );
  RexxModuleInitialize();

  extern char startInputQueueMonitor;
  void _Optlink inputQueueMonitor( void * );
  void _Optlink status( void * );
  void _Optlink statusFiction( void * );

  if( !detachedSession )
  {
    if( startInputQueueMonitor )
    {
      queueMonitor = _beginthread( inputQueueMonitor, 0, 40960, NULL );

      if( queueMonitor == -1 )
        log( Msg_ErrMdmQueMon, strError() );
      else
        log( Msg_ThrMdmQueMon, queueMonitor );
    }

    statusTh = 0;

    if( miscInfo.state1&StatusLine )
      statusTh = _beginthread( status, 0, 40960, NULL );
    else if( miscInfo.state&ModemWindow )
      statusTh = _beginthread( statusFiction, 0, 40960, NULL );

    if( statusTh==0xffffffffl )
      log( Msg_ErrStatusLine, strError() );
    else if( statusTh )
      log( Msg_ThrStatusLine, statusTh );
    else
      statusTh = 0xffffffffl;

    if( !noPMFeatures )
      changeIcon();
  }

  void startSplitter();

  if( !onlineAnswer )
    startSplitter();

  void _Optlink bsyProcessor( void* );
  void resetBsy( int task );

  if( !onlineAnswer )
    resetBsy( 1 );

  if( miscInfo.bsyInterval && !onlineAnswer )
    if( checkUsage( "Task\\Bsy.Processor.Is.Active" ) )
      log( Msg_ErrActiveBsyProc );
    else
      if( (bsyTID = _beginthread( bsyProcessor, 0, 40960, NULL ))==0xffffffffl )
        log( Msg_ErrBsyProc, strError() );
      else
        log( Msg_ThrBsyProc, bsyTID );

  if( (flagCount && flagList!=NULL) || (noFlagCount && noFlagList!=NULL) ||
      miscInfo.exitFlag!=NULL && !onlineAnswer )
  {
    void _Optlink processFlags( void * );

    if( (flagsTID = _beginthread( processFlags, 0, 40960, NULL ))==0xffffffffl )
      log( Msg_ErrFlagsProc, strError() );
    else
      log( Msg_ThrFlagsProc, flagsTID );
  }

  initFileInfo( 0 );

  classLibLockNeed = 1;
  return 0;
}

void startSchedule()
{
  if( schedList==NULL || !schedCount || onlineAnswer )
    return;

  void _Optlink scheduleProcess( void * );

  if( (schedTID = _beginthread( scheduleProcess, 0, 40960, NULL ))==0xffffffffl )
    log( Msg_ErrSchedProc, strError() );
  else
    log( Msg_ThrSchedProc, schedTID );
}

void returnSystemScreen()
{
  if( !detachedSession )
  {
    setVideoMode( savedVio.col, savedVio.row );
    restoreScreen();
  }

  +screenCursor;
  delete screenCursorPtr;
}

void dataDeInit()
{
  if( systemIsReady )
  {
    void abortRescanServer();
    void stopCompile();
    void abortScheduleProcess();
    void abortFlagProcess();
    void splitterDone();
    void abortQueueMonitor();
    void deInitBeepProcess();

    time_t
           deInitAllB( 0 ),
           deInitAllE( 0 ),
           deInitScheduleB( 0 ),
           deInitScheduleE( 0 ),
           deInitFlagsB( 0 ),
           deInitFlagsE( 0 ),
           deInitRescanB( 0 ),
           deInitRescanE( 0 ),
           deInitCompileB( 0 ),
           deInitCompileE( 0 ),
           deInitSplitB( 0 ),
           deInitSplitE( 0 ),
           deInitQueMonB( 0 ),
           deInitQueMonE( 0 ),
           deInitBeepB( 0 ),
           deInitBeepE( 0 ),
           deInitClipB( 0 ),
           deInitClipE( 0 );

    deInitAllB = getMSec();

    if( schedTID!=0xffffffffl )
      abortScheduleProcess();

    if( flagsTID!=0xffffffffl )
      abortFlagProcess();

    if( schedTID!=0xffffffffl )
    {
      deInitScheduleB = getMSec();
      log( Msg_DeInitAAA, Msg_DeInitSchedule );
      DosWaitThread( (PTID)&schedTID, DCWW_WAIT );
      deInitScheduleE = getMSec();
    }

    if( flagsTID!=0xffffffffl )
    {
      deInitFlagsB = getMSec();
      log( Msg_DeInitAAA, Msg_DeInitFlags );
      DosWaitThread( (PTID)&flagsTID, DCWW_WAIT );
      deInitFlagsE = getMSec();
    }

    deInitRescanB = getMSec();
    log( Msg_DeInitAAA, Msg_DeInitRescan );
    abortRescanServer();
    deInitRescanE = getMSec();

    deInitCompileB = getMSec();
    log( Msg_DeInitAAA, Msg_DeInitCompile );
    stopCompile();
    deInitCompileE = getMSec();

    deInitSplitB = getMSec();
    log( Msg_DeInitAAA, Msg_DeInitSplit );
    splitterDone();
    deInitSplitE = getMSec();

    abortQueueMonitor();

    if( statusTh!=0xffffffffl )
    {
      deInitQueMonB = getMSec();
      log( Msg_DeInitAAA, Msg_DeInitQueMon );
      statusAbort = 1;
      DosWaitThread( (PTID)&statusTh, DCWW_WAIT );
      deInitQueMonE = getMSec();
    }

    deInitBeepB = getMSec();
    log( Msg_DeInitAAA, Msg_DeInitBeep );
    deInitBeepProcess();
    deInitBeepE = getMSec();

    deInitClipB = getMSec();
    log( Msg_DeInitAAA, Msg_DeInitClip );
    ClipConsoleDeInitialize();
    deInitClipE = getMSec();

    disableScreenSaver();
    RexxModuleDeInitialize();

    delete comPort;
    comPort = NULL;

    deInitAllE = getMSec();

    dataDeInitMsg( deInitScheduleE-deInitScheduleB, Msg_DeInitSchedule );
    dataDeInitMsg( deInitFlagsE-deInitFlagsB, Msg_DeInitFlags );
    dataDeInitMsg( deInitRescanE-deInitRescanB, Msg_DeInitRescan );
    dataDeInitMsg( deInitCompileE-deInitCompileB, Msg_DeInitCompile );
    dataDeInitMsg( deInitSplitE-deInitSplitB, Msg_DeInitSplit );
    dataDeInitMsg( deInitQueMonE-deInitQueMonB, Msg_DeInitQueMon );
    dataDeInitMsg( deInitBeepE-deInitBeepB, Msg_DeInitBeep );
    dataDeInitMsg( deInitClipE-deInitClipB, Msg_DeInitClip );
    dataDeInitMsg( deInitAllE-deInitAllB, Msg_DeInitAll );

    delete logPtr;
    logPtr = NULL;

    systemIsReady = 0;

    delete wndQueuePtr;

    if( (miscInfo.state&ModemWindow)==ModemWindow )
    {
      delete wndModemPtr;
      delete wndModemFrame;
    }

    delete wndLogPtr;
    delete wndStatPtr;

    if( (miscInfo.state1&StatusLine)==StatusLine )
    {
      delete statusLineWindowPtr;
      delete headLineWindowPtr;
    }

    delete masterScreenPtr;

    returnSystemScreen();
  }

  void deInitProfile();

  deInitProfile();
  deInitPMFeatures();
  delete addInQueueList;
}

static Register *registerRecord;
static FILE *keyFile;
char *ownerName=NULL;
static unsigned long crc;

int get( char *p )
{
  for( int i=0; p[i]; i++ )
  {
    int ch = getc( keyFile );

    if( ch==EOF || ch!=p[i] )
      return 1;
  }

  return 0;
}

int CheckKey()
{
  registerRecord->serial = 0;
  memset( registerRecord->owner, ' ', sizeof(registerRecord->owner) );

  char keyName[] = "Brake!.Key";

  keyFile = _fsopen( keyName, "r" );

  if( keyFile==NULL )
  {
    char *keyPath = (char *)_alloca( strlen(brakeLoadPath)+sizeof(keyName) );

    strcpy( keyPath, brakeLoadPath );
    strcat( keyPath, keyName );

    keyFile = _fsopen( keyPath, "r" );

    if( keyFile==NULL )
      return 0;
  }

  if( get("OwnerName \"") )
  {
Illegal:
    fclose( keyFile );
    registerRecord->serial = 0;
    return 1;
  }

  int ch( 0 );

  for( int i=0; i<sizeof(registerRecord->owner); i++ )
  {
    ch = getc( keyFile );

    if( ch==EOF )
      goto Illegal;

    if( ch=='"' )
      break;

    registerRecord->owner[i] = char(ch);
  }

  if( ch!='"' )
    goto Illegal;

  if( get( "\n\nSerialNumber " ) )
    goto Illegal;

  registerRecord->serial=0;

  for( i=0; i<16; i++ )
  {
    ch = getc( keyFile );

    if( ch<'0' || ch>'9' )
      goto Illegal;

    registerRecord->serial = registerRecord->serial*10 + (ch-'0');
  }

  if( get( " AccessKey " ) )
    goto Illegal;

  registerRecord->crc=0;

  for( i=0; i<16; i++ )
  {
    ch = getc( keyFile );

    if( ch<'0' || ch>'9' )
      goto Illegal;

    registerRecord->crc = registerRecord->crc*10 + (ch-'0');
  }

  if( get( "\n\nRSASignature\n\n" ) )
    goto Illegal;

  int j;

  for( i=0, j=0; i<sizeof(registerRecord->signature); )
  {
    ch = getc( keyFile );

    if( ++j==65  )
      if( ch!='\n' )
	goto Illegal;
      else
        j=0;
    else
      if( (ch>='A' && ch<='Z') || (ch>='a' && ch<='z') )
        registerRecord->signature[i++] = char(ch);
      else
        goto Illegal;
  }

  if( get( "\n\n\nEnd." ) )
    goto Illegal;

  if( getc(keyFile)!=EOF )
    goto Illegal;

  crc = 0xffffffffl;

  unsigned char *p = (unsigned char *)&registerRecord->serial;

  for( i=0; i<sizeof(registerRecord->serial); i++ )
    crc = Z_32UpdateCRC( p[i], crc );

  p = (unsigned char *)registerRecord->owner;

  for( i=0; i<sizeof(registerRecord->owner); i++ )
    crc = Z_32UpdateCRC( p[i], crc );

  p = (unsigned char *)registerRecord->signature;

  for( i=0; i<sizeof(registerRecord->signature); i++ )
    crc = Z_32UpdateCRC( p[i], crc );

  if( registerRecord->crc!=crc )
    goto Illegal;

  for( i=sizeof(registerRecord->owner)-1; i>=0 && registerRecord->owner[i]==' '; i-- )
    if( registerRecord->crc!=crc )
      goto Illegal;

  registerRecord->owner[ i+1 ] = 0;

  if( registerRecord->crc!=crc )
    goto Illegal;

  ownerName = newStr( registerRecord->owner );

  if( registerRecord->crc!=crc )
    goto Illegal;

  fclose( keyFile );

  if( registerRecord->crc!=crc )
    goto Illegal;

  return 0;
}

extern char *ctlName;
extern char needDumpOnly;
char isRegisterdVersion = 0;
char detectKillProcess = 1;

int firstInit( int argn, char **argc )
{
  registerRecord = new Register;

  int reg = CheckKey();

  if( registerRecord->crc!=crc )
    registerRecord->serial=0;

  if( !reg && registerRecord->serial )
  {
    if( registerRecord->crc!=crc )
      registerRecord->serial=0;

    M_NUMBER = new char [16];
    sprintf( (char *)M_NUMBER, "%04lu", registerRecord->serial );
    isRegisterdVersion = 1;
  }

  log( "\r\n%s Version %s, serial #%s.", M_NAME, M_VERSION, M_NUMBER );
  log( "\n%s\n", M_COPYRIGHT );

  if( reg )
  {
    if( registerRecord->crc!=crc )
      registerRecord->serial=0;

    isRegisterdVersion = 0;
    log( Msg_RegisterIllegal );
  }

  if( registerRecord->serial && ownerName!=NULL )
    log( Msg_RegisterdTo, ownerName );
  else
    log( Msg_RegisterdNone );

  delete registerRecord;

  char *optUsed( "dc:l:n:apq:t0s:ob:g:h:f~km@i" );
  int option;
  char *end;
  char *sharedQueueName = "Brake's Shared Queue";
  char floatOnTop = 1;

  GetOptBlock block =
  {
    1,
    0,
    NULL,
    "",
    NULL
  };
  char binaryKbd( 1 );
  static char console[]( "/dev/con" );

  while( (option=getopt( argn, argc, optUsed, &block ))!=-1 )
    switch( option )
    {
    case '@':
      heapDebug++;
      break;

    case 'm':
      miscInfo.enableMMPM = 0;
      break;

    case 'k':
      detectKillProcess = 0;
      break;

    case 'i':
      daemonMode = sopen( console, O_WRONLY|O_TEXT|O_NOINHERIT, SH_DENYNO, S_IWRITE );
      if( daemonMode==-1 )
        log( Msg_ErrUnableOpen, console, strError() );
      break;

    case 'g':
      callOneNode = new FIDOAddress( block.optarg );
      onlineAnswer = 1;

      if( !callOneNode->isValid() )
      {
        log( Msg_ErrIllegalAddress, block.optarg );
        return 1;
      }
      break;

    case 'o':
      onlineAnswer = 1;
      break;

    case '~':
      needBonus = 0;
      break;

    case 'f':
      floatOnTop = 0;
      break;

    case 'b':
      onlineAnswerBaud = int( strtoul( block.optarg, &end, 10 ) );

      if( *end )
      {
        log( Msg_ErrOnLineAnswerB, block.optarg );
        onlineAnswerBaud = 300;
        return 1;
      }

      if( !onlineAnswerBaud )
      {
        log( Msg_ErrOnLineAnswerZeroB );
        onlineAnswerBaud = 300;
        return 1;
      }
      break;

    case 'h':
      onlineHandle = int( strtoul( block.optarg, &end, 10 ) );

      if( *end )
      {
        log( Msg_ErrOnLineAnswer, block.optarg );
        return 1;
      }
      break;

    case '0':
      noPMFeatures = 1;
      break;

    case 't':
      terminalActive = 1;
      break;

    case 'a':
      binaryKbd = 0;
      break;

    case 'p':
      listConfig = 1;
      break;

    case 'c':
      ctlName = block.optarg;
      capitalize( ctlName );
      break;

    case 's':
      sharedQueueName = block.optarg;
      capitalize( sharedQueueName );
      break;

    case 'l':
      miscInfo.taskNumber = (long)strtoul( block.optarg, &end, 10 );

      if( *end )
      {
        log( Msg_ErrTaskNumber, block.optarg );
        miscInfo.taskNumber = 1;
      }

      if( !miscInfo.taskNumber )
      {
        log( Msg_ErrTaskNumberZero );
        miscInfo.taskNumber = 1;
      }

      break;

    case 'n':
      nodeListCacheSize = (long)strtoul( block.optarg, &end, 10 );

      if( *end )
      {
        nodeListCacheSize = 150;
        log( Msg_ErrCacheSize, block.optarg, nodeListCacheSize );
      }
      break;

    case 'q':
      sharedMemoryQueueSize = (long)strtoul( block.optarg, &end, 10 );

      if( *end )
      {
        sharedMemoryQueueSize = 60;
        log( Msg_ErrQueueSize, block.optarg, sharedMemoryQueueSize );
      }
      break;

    case 'd':
      needDumpOnly = 1;
      break;

    default:
      log( block.error, block.optopt );
      break;
    }

  while( block.optind<argn )
  {
    log( Msg_ErrExtraParameter, argc[block.optind] );
    block.optind++;
  }

  checkDetach();

  if( initPMFeatures() )
    return 1;

  if( reg )
  {
    if( registerRecord->crc!=crc )
      registerRecord->serial=0;

    isRegisterdVersion = 0;
    log( Msg_RegisterIllegal );
  }

  if( !isRegisterdVersion )
    if( pmMessage( "-= Hackers attack =-",
                   "This is a cracked version of The Brake!(tm) Mailer"
                   " or you have not the registration key!" )==3 )
      return 3;

  void initProfile();

  initProfile();

  PTIB tib;
  PPIB pib;

  DosGetInfoBlocks( &tib, &pib );

  isFullScreen = char( UCHAR(pib->pib_ultype)==0 );

  if( isFullScreen && !noPMFeatures && !detachedSession && floatOnTop )
  {
    BrakeSwitchToForeground( winTitleObject );
  }

  if( !detachedSession && binaryKbd && !isFullScreen )
    setBinaryKbdMode();

  if( reg )
  {
    if( registerRecord->crc!=crc )
      registerRecord->serial=0;

    isRegisterdVersion = 0;
  }

  sprintf( pszAppBrake+strlen(pszAppBrake), " Task %d", miscInfo.taskNumber );

  arqList = new CallsList;
  arqList->Add( *new Calls( "/MNP", NULL ) );
  arqList->Add( *new Calls( "/REL", NULL ) );
  arqList->Add( *new Calls( "/COMP", NULL ) );
  arqList->Add( *new Calls( "/V42", NULL ) );
  arqList->Add( *new Calls( "/LAP", NULL ) );
  arqList->Add( *new Calls( "/ZYX", NULL ) );
  arqList->Add( *new Calls( "/HST", NULL ) );
  arqList->Add( *new Calls( "/TEL", NULL ) );
  arqList->Add( *new Calls( "/VMO", NULL ) );
  arqList->Add( *new Calls( "/ARQ", NULL ) );
  arqList->Add( *new Calls( "FAST", NULL ) );

  halfDuplexList = new CallsList;
  noHydraChatList = new NoHydraChatList;

  if( reg )
  {
    if( registerRecord->crc!=crc )
      registerRecord->serial=0;

    isRegisterdVersion = 0;
  }

  systemList  = new NodeConfigList;
  maskList    = new NodeConfigList;
  queue       = new Queue( SemaphoreModeNeed );

  if( Nodelist::createNodeListMutex() )
    return 1;

  if( Queue::initStatic( sharedQueueName ) )
    return 1;

  processTable = new ProcessList;
  onlineTable = new ProcessList;
  immediateTable = new ProcessList;
  ignoreString = new ModemStringList;
  badCounterString = new ModemStringList;

  addInQueueList = new AddInQueueList;

  memset( terminalInXLAT, 0xff, sizeof(terminalInXLAT) );
  memset( terminalOutXLAT, 0xff, sizeof(terminalOutXLAT) );
  memset( &colorSet, 0, sizeof(colorSet) );
  colorSet.isColor = 1;

  void executeBBS();
  void internalLogin();

  Pair *pPair = new Pair( "\033\033", executeBBS ),
       *p1Pair = new Pair( "\03\03\03", internalLogin );

  handShakeList = (Pair *)malloc( sizeof(Pair)*2 );
  handShakeCount = 2;
  memcpy( handShakeList, pPair, sizeof(Pair) );		//易⥫쭮 !!!
  memcpy( handShakeList+1, p1Pair, sizeof(Pair) );

  keyClear();

  return 0;
}

int firstFirstInit()
{
  systemStartTime = getTimeMark();

  if( strcmp( Msg_AAABUILD_VERSION, M_VERSION ) )
  {
    log( Msg_AAABUILD_VERSION_ILL, M_VERSION );
    return 1;
  }

  if( InitVioSystem() )
    return 1;

  if( InitKbdSystem() )
    return 1;

  if( getenv( "TZ" )==NULL )
  {
    static char tz[]="TZ=MSK-3MSD";

    log( Msg_InfoTZ, tz );

    if( putenv( tz ) )
      log( Msg_ErrUnableAdd, tz );
  }

  buildHydraCrc();

  if( setlocale( LC_ALL, localeName )==NULL )
    log( Msg_ErrNoLocale, localeName );

  tzset();

  sleeper = new Sleeper;

  if( !sleeper->isValid() )
    return 1;

  int initResourceSemaphore();

  if( initResourceSemaphore() )
  {
    log( Msg_ErrNoResourceSema );
    return 1;
  }

  return 0;
}
