#define INCL_KBD
#include <os2.h>

#include <malloc.h>
#include <string.h>

#include "key.h"

APIRET16 (* APIENTRY16 RealKbdCharIn)( PKBDKEYINFO, USHORT, HKBD );
APIRET16 (* APIENTRY16 RealKbdPeek)( PKBDKEYINFO, HKBD );

static char *saveList = NULL;
static char *headSaveList = NULL;
static KBDKEYINFO oldInfo;

void fill( PKBDKEYINFO info )
{
  memcpy( info, &oldInfo, sizeof(KBDKEYINFO) );
  info->chChar = *saveList;
  info->chScan = *saveList;
}

extern char *(* APIENTRY BrakeGetFromClipboard)( void );

char *getFromClipboard( void )
{
  if( BrakeGetFromClipboard!=NULL )
    return BrakeGetFromClipboard();

  return NULL;
}

APIRET16 APIENTRY16 KbdCharIn( PKBDKEYINFO info, USHORT fWait, HKBD hkbd )
{
  APIRET16 rc = 0;

  if( saveList != NULL )
FromList:
    if( *saveList )
    {
      fill( info );
      saveList++;
      return 0;
    }
    else
    {
      DosFreeMem( headSaveList );
      saveList = NULL;
      headSaveList = NULL;
    }

  rc = RealKbdCharIn( info, fWait, hkbd );

  if( !rc &&
      (info->fbStatus & 2) && 
      ((info->chChar == 0) || (info->chChar == 0xe0 && info->chScan)) &&
      (info->chScan == 0x52 && info->fsState&0x03)
    )
  {
    memcpy( &oldInfo, info, sizeof(KBDKEYINFO) );
    oldInfo.fsState = (USHORT)(info->fsState & 0xf0f0);
    oldInfo.fbStatus = 0x40;

    if( headSaveList!=NULL )
      DosFreeMem( headSaveList );

    saveList = getFromClipboard();
    headSaveList = saveList;

    goto FromList;
  }

  return rc;
}

APIRET16 APIENTRY16 KbdPeek( PKBDKEYINFO info, HKBD hkbd )
{
  if( saveList != NULL && *saveList )
  {
    fill( info );
    return 0;
  }

  return RealKbdPeek( info, hkbd );
}
