/* rexx */

parse arg file;

if file='' then file = 'brakee.map';

list = 'braketrc.cpp';

say file '->' list '...'


'@del /f' list '>nul 2>&1'

modules.0 = 0;

call BuildModules;

header = '  Address         Publics by Value';

do while lines( file )
  in = linein( file );
  if in=header then Signal Start;
end;

say 'Not found';
exit;

Start:

Call lineout list, 'struct ModuleList';
Call lineout list, '{';
Call lineout list, '  unsigned long seg;';
Call lineout list, '  unsigned long off;';
Call lineout list, '  char *type;';
Call lineout list, '  char *module;';
Call lineout list, '  char *func;';
Call lineout list, '};';
Call lineout list, '';
Call lineout list, 'static struct ModuleList internalModuleList[] =';
Call lineout list, '{';

do while lines( file )
  in = linein( file );

  if words( in ) <> 2 then iterate;

  parse value word( in, 1 ) with seg':'off;

  module = locate( seg, off );
  mumu = translate( word( in, 2 ), '/', '\' )

  call lineout list, '  0x'||seg||', 0x'||off||', "'||module||'", "'||mumu||'",';
end;

Call lineout list, '  0x0, 0x0, 0x0, 0x0, 0x0';
Call lineout list, '};';
Call lineout list, '';
Call lineout list, '#include "braketrc.h"';

exit;

BuildModules: procedure expose modules. file;

/* 0001:00000000 0000DDE12H CODE32                 CODE 32-bit*/

seg = 0;
base = 0;
type = '*BUG*';

do while lines( file )
  in = linein( file );

  if in == ' Origin   Group' then leave;

  if words( in )=5 then
    if substr(word( in, 5 ), 3, 4 )='-bit' then
    do
      parse value word( in, 1 ) with seg1':'off1;
      seg = x2d( seg1 );
      base = x2d( off1 );
      type = word( in, 4 );
      iterate;
    end;

  if word( in, 1 ) <> '	at' then iterate;

  modules.0 = modules.0+1;
  i = modules.0;

  parse value word( in, 8 ) with '('mumu')';

  locSeg = right( d2x( seg ), 4, '0' );
  locOff = right( d2x( base+x2d( word( in, 3 ) ) ), 8, '0' );

  modules.i = locSeg||' '||locOff||' '||type||' '||mumu;
end;

return;

locate: procedure expose modules.;	/* ( seg, off ) */
seg = x2d( arg(1) );
off = x2d( arg(2) );

prev = 1;

do i=2 to modules.0
  segIn = x2d( word( modules.i, 1 ) );
  offIn = x2d( word( modules.i, 2 ) );
  if seg < segIn then leave;
  if off < offIn then leave;
  prev = i;
end;

return word( modules.prev, 3 )||'", "'||translate( word( modules.prev, 4 ), '/', '\' );
