#include <string.h>

#include "nolog.h"
#include "newstr.h"

NoLog::NoLog( char *f ) :
  str( newStr( f ) )
{}

NoLog::~NoLog()
{
  delete str;
}

int NoLog::equal( const BaseObject &t ) const
{
  return !stricmp( str, (*(const NoLog *)&t).str );
}

void NoLog::print( ostream& s ) const
{
  s << str;
}

char *NoLog::nameOfClass() const
{
  return "NoLog";
}

int NoLog::beginIn( char *s ) const
{
  return !strnicmp( s, str, strlen( str ) );
}

NoLogList::NoLogList() :
  Collection( 10, 5, SemaphoreModeNoNeed )
{
}

NoLog* NoLogList::Find( NoLog& item, LockMode lock ) const
{
  return (NoLog*)Collection::Find( item, lock );
}
    
NoLog& NoLogList::operator [] ( const int pos ) const
{
  return *(NoLog *)&(Collection::operator[]( pos ));
}

int NoLogList::found( char *s ) const
{
  for( int i(0); i<used; i++ )
    if( ((NoLog *)list[i])->beginIn( s ) )
      return 1;

  return 0;
}

NoLogIterator::NoLogIterator( NoLogList& ini ) :
  CollectionIterator( *(Collection *)&ini )
{
}

NoLog& NoLogIterator::operator () () const
{
  return *(NoLog *)&(CollectionIterator::operator()());
}
