#include "newstr.h"
#include "rcvdlist.h"

ReceivedFile::ReceivedFile( char *nm ) :
  path( newStr( nm ) )
{}

ReceivedFile::~ReceivedFile()
{
  delete path;
}

int ReceivedFile::equal( const BaseObject &t ) const
{
  return !stricmp( path, (*(const ReceivedFile *)&t).path );
}

void ReceivedFile::print( ostream& s ) const
{
  s << path;
}

char *ReceivedFile::nameOfClass() const
{
  return "ReceivedFile";
}

ReceivedFileList::ReceivedFileList() :
  Collection( 5, 5, SemaphoreModeNeed )
{
}

ReceivedFile* ReceivedFileList::Find( ReceivedFile& item, LockMode lock ) const
{
  return (ReceivedFile*)Collection::Find( item, lock );
}
    
ReceivedFile& ReceivedFileList::operator [] ( const int pos ) const
{
  return *(ReceivedFile *)&(Collection::operator[]( pos ));
}

ReceivedFileIterator::ReceivedFileIterator( ReceivedFileList& ini ) : 
  CollectionIterator( *(Collection *)&ini )
{
}

ReceivedFile& ReceivedFileIterator::operator () () const
{
  return *(ReceivedFile *)&(CollectionIterator::operator()());
}
