#ifndef __REXXHOOK_H

#define __REXXHOOK_H

#include "class.h"

char *processRexxHookBoth( int log, char *name,
                           char *a1=NULL, char *a2=NULL, char *a3=NULL,
                           char *a4=NULL, char *a5=NULL, char *a6=NULL,
                           int needResult = 0 );

char *processRexxHook( char *name,
                       char *a1=NULL, char *a2=NULL, char *a3=NULL,
                       char *a4=NULL, char *a5=NULL, char *a6=NULL,
                       int needResult = 0 );

char *processRexxHookNoLog( char *name,
                            char *a1=NULL, char *a2=NULL, char *a3=NULL,
                            char *a4=NULL, char *a5=NULL, char *a6=NULL,
                            int needResult = 0 );

char *getRexxHook( char *name );
int processLogicalRexxHook( char *name,
                            char *a1=NULL, char *a2=NULL, char *a3=NULL,
                            char *a4=NULL, char *a5=NULL, char *a6=NULL );

class RexxHook : public BaseObject
{
  char *hook,
       *proc;

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

public:
  RexxHook( char *_h, char *_p );
  ~RexxHook();

  char *getHook() const { return hook; }
  char *getProc() const { return proc; }
};

class HookList : public Collection		//RexxHook
{
public:
  HookList();

  RexxHook* Find( RexxHook& item, LockMode lock=LockModeNeed ) const;
  RexxHook& operator [] ( const int pos ) const;
};

class HookIterator : public CollectionIterator	//RexxHook
{
public:
  HookIterator( HookList& ini );

  RexxHook& operator () () const;
};

extern HookList *rexxHookList;

#endif
