#ifndef __SHMEM_H

#define __SHMEM_H

class SharedMemory
{
  char *base,
       *current,
       *end;
  long size;
  char *name;
  int allocated;

public:

  SharedMemory( char *name, long size );
  ~SharedMemory();

  void *getBase() const { return (void*)base; }
  void *getEnd()  const { return (void*)end; }
  long getSize()  const { return size; }
  char *getName() const { return name; }

  int isOk() const { return base!=0; }
  int isAllocated() const { return allocated; }
  
  int eof() const { return current>=end; }
  int tell() const { return current-base; }
  void reset() { current=base; }

  void seek( int p );
  int write( void *ptr, long size );
  int read( void *ptr, long size );
};

#endif