#define INCL_DOS
#include <os2.h>

#include "timer.h"
#include "misc.h"

Timer::Timer( unsigned long time )
{
  startTimer( time );
}

Timer::~Timer()
{
  endTimer();
}

void Timer::endTimer()
{
  start = 0;
}

void Timer::sleep( short secs )
{
  startTimer( secs*1000 );
  waitTimer();
  endTimer();
}

void Timer::waitTimer() const
{
  if( start )
    while( !isTimeOut() )
      checkPoint();
}

void Timer::startTimer( unsigned long msecs )
{
  if( msecs )
  {
    ULONG mark(0);

    DosQuerySysInfo( QSV_MS_COUNT, QSV_MS_COUNT, &mark, sizeof mark );

    start = mark + msecs;
  }
  else
    start = 0;
}

int Timer::isTimeOut() const
{ 
  ULONG mark(0);

  DosQuerySysInfo( QSV_MS_COUNT, QSV_MS_COUNT, &mark, sizeof mark );

  return mark>start;
}

unsigned long Timer::rest() const
{
  ULONG mark(0);

  DosQuerySysInfo( QSV_MS_COUNT, QSV_MS_COUNT, &mark, sizeof mark );

  return (mark>=start) ? 0 : start - mark;
}

int Timer::secsLeft() const
{
  register unsigned long i( rest()/1000 );

  return int( (rest()%1000) ? i+1 : i );
}

unsigned long minTimer( Timer& t1, Timer& t2 )
{
  register unsigned long w1( t1.rest() ), w2( t2.rest() );
  return w1<w2 ? w1 : w2;
}
