#ifndef _WINHANDLE_H

#define _WINHANDLE_H

#include "class.h"
#include "window.h"

class WindowHandle : public BaseObject
{
  Window *win;

  int equal( const BaseObject &t ) const;
  void print( ostream& s ) const;
  char *nameOfClass() const;

public:
  WindowHandle( Window *w );
  ~WindowHandle();

  Window *getWindow() const { return win; }
  void setWindow( Window *_win );
};

class WindowHandleList : public Collection		//WindowHandle
{
public:
  WindowHandleList();

  WindowHandle* Find( WindowHandle& item, LockMode lock=LockModeNeed ) const;
  WindowHandle& operator [] ( const int pos ) const;
};

class WindowHandleIterator : public CollectionIterator	//WindowHandle
{
public:
  WindowHandleIterator( WindowHandleList& ini );

  WindowHandle& operator () () const;
};

#endif