#define INCL_DOS
#define INCL_DOSEXCEPTIONS
#include <os2.h>

#include <time.h>
#include <stdio.h>
#include <process.h>

#include "except.h"

#include "language.h"

#include "misc.h"
#include "zinter.h"
#include "zdialog.h"
#include "filetype.h"
#include "session.h"

static Window *zWnd = NULL;

static char *msg = NULL;

static volatile long fileLength = 0,
                     startTime = 0,
                     startPos = 0,
                     curPos = 0;

static volatile char abortDrawZInfo = 0;
static long drawThr=0xffffffff;

volatile int zinfoCount = 0;
volatile int zinfoTry = 0;
volatile long zinfoPos = 0;
volatile int zinfoCps = 5000;

void zInitWin()
{
  if( !detachedSession )
  {
    zWnd->drawTransact( 2, 3, stdColor, Msg_ZDFileName );
    zWnd->drawTransact( 10, 3, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 4, stdColor, Msg_ZDFileSize );
    zWnd->drawTransact( 10, 4, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 5, stdColor, Msg_ZDFilePos );
    zWnd->drawTransact( 10, 5, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 6, stdColor, Msg_ZDFileBlock );
    zWnd->drawTransact( 10, 6, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 7, stdColor, Msg_ZDFileCps );
    zWnd->drawTransact( 10, 7, stdColor, Msg_ZDNone );

    zWnd->drawTransact( 2, 8, stdColor, Msg_ZDFileTime );
    zWnd->drawTransact( 10, 8, stdColor, Msg_ZDNone );
  }

  zinfoCount = 0;
  zinfoTry = 0;
  zinfoPos = 0;
  zinfoCps = comPort->getLastBaud()/10;

  fileLength = 0;
  startTime = getTimeMark();
  startPos = 0;
  curPos = 0;
}

void _Optlink drawZInfoFic( void * )
{
  registerExceptionHandler

  for( ; !abortDrawZInfo; sleep( 100 ) )
  {
    curPos = zinfoPos;

    long elapsed( getTimeMark() - startTime );

    if( elapsed <= 0 )
      elapsed = 1;

    elapsed = (curPos-startPos)/elapsed;

    if( elapsed < 0 )
      elapsed = 0;

    zinfoCps = int(elapsed);
  }

  deRegisterExceptionHandler
}

void _Optlink drawZInfo( void * )
{
  registerExceptionHandler

  char buf[80];

  int count = -1;
  int tryCnt = -1;
  long pos = -1;
  long wasElapsed = -1;

  for( ; !abortDrawZInfo; sleep( 100 ) )
  {
    long elapsed( getTimeMark() );

    if( wasElapsed!=elapsed )
    {
      elapsed -= startTime;

      long oldElapsed( elapsed );

      if( elapsed <= 0 )
        elapsed = 1;

      elapsed = (curPos-startPos)/elapsed;

      if( elapsed < 0 )
        elapsed = 0;

      char *ss = strNumber( elapsed );

      sprintf( buf, "%s, %lu%%", ss, makePercent( comPort->getLastBaud(),
                                                  elapsed*10 ) );
      zWnd->drawTransactField( 10, 7, stdColor, buf );
      delete ss;

      long work( elapsed ? elapsed : comPort->getLastBaud()/10 );

      if( !work )
        work = 1;

      long rest( (fileLength - curPos) / work);

      char buf1[32],
           buf2[32],
           buf3[4] = { ' ', '/', ' ', 0 };

      makeTime( buf1, oldElapsed );
      makeTime( buf2, rest );
      buf3[1] = timeDelimiter;
      strcpy( buf, buf1 );
      strcat( buf, buf3 );
      strcat( buf, buf2 );

      zWnd->drawTransactField( 10, 8, stdColor, buf );
      zinfoCps = int(elapsed);
    }

    if( count!=zinfoCount )
    {
      char *ss = strNumber( zinfoCount );

      count = zinfoCount;
      zWnd->drawTransactField( 10, 6, stdColor, ss );
      delete ss;
    }

    if( pos!=zinfoPos )
    {
      char *ss = strNumber( zinfoPos );

      pos = zinfoPos;
      sprintf( buf, "%s, %lu%%", ss, makePercent( fileLength ? fileLength : 1,
                                                  zinfoPos ) );
      zWnd->drawTransactField( 10, 5, stdColor, buf );
      curPos = pos;
      delete ss;
    }

    if( zinfoTry && zinfoTry!=tryCnt )
    {
      tryCnt = zinfoTry;
      sprintf( buf, "[%2d]", tryCnt );
      zWnd->drawTransactField( 21, 5, stdColor, buf );
    }
  }

  deRegisterExceptionHandler
}

void infoDisplayStart()
{
  if( zWnd!=NULL )
  {
    log( "infoDisplayStart -  㦥 !" );
    return;
  }

  abortDrawZInfo = 0;

  if( !detachedSession )
  {
    int delta = (miscInfo.state1&StatusLine)==StatusLine ? 0 : 1;

    if( terminalActive )
      zWnd = new Window( Z_ScreenWidth-28, 3-delta, 27, 11, stdColor,
                         NULL, BS_SINGLELINE, DS_LOWERRIGHT );
    else
      zWnd = new Window( Z_ScreenWidth-25, 3-delta, 25, 9, stdColor );

    zWnd->drawTransact( 2, 2, stdColor, Msg_ZDBegin );
    zInitWin();

    +*zWnd;

    drawThr = _beginthread( drawZInfo, 0, 40960, 0 );
  }
  else
    drawThr = _beginthread( drawZInfoFic, 0, 40960, 0 );
}

void infoDisplayEnd()
{
  abortDrawZInfo = 1;
  DosWaitThread( (PTID)&drawThr, DCWW_WAIT );

  if( !detachedSession )
  {
    delete zWnd;
    zWnd = NULL;
  }
}

void infoDisplayMsg( char *state, char *action )
{
  if( zWnd==NULL )
    return;

  char buf[ 132 ];

  memset( buf, ' ', sizeof(buf) );
  strcpy( buf+(5-strlen(action)+2-2), action );
  strcat( buf, " : " );
  strcat( buf, state );

  zWnd->lock();
  zWnd->drawTransact( 2, 2, stdColor, buf );
  zInitWin();
  zWnd->unlock();

  msg = action;
}

void infoDisplayName( int crc, char *protocol, char *realname,
		      long file_length, char *ascii, char *alias,
                      char *protocolShort )
{
  fileLength = file_length;

  long appro( (file_length*10) / comPort->getLastBaud() );
  char *file = fileName( realname ),
       *fil,
       *who = msgOfFileType( alias!=NULL ? alias : file, NULL ),
       *ss = strNumber( file_length );

  makeFileCase( realname );

  if( msg==Msg_ZScrReceive )
    log( Msg_ZDReceive, file,
         protocolShort, crc,
         ss,
         appro/60, int( appro%60 ),
         who );
  else
    log( Msg_ZDSend, file,
         alias==NULL ? "" : " -> ",
         alias==NULL ? "" : alias,
         protocolShort, crc,
         ss,
         appro/60, int( appro%60 ),
         who );

  if( zWnd==NULL )
    return;

  char buf[80];

  sprintf( buf, "%s-%d", protocol, crc );
  zWnd->drawTransactField( 10, 2, stdColor, buf );
  zWnd->drawTransactField( 10, 3, stdColor, alias!=NULL ? alias : file );
  zWnd->drawTransactField( 10, 4, stdColor, ss );

  delete ss;
}

void infoDisplayMarkTime( long start )
{
  startTime = getTimeMark();
  startPos = start;
  infoDisplayPos( start );
}

void infoDisplayDone( long size, long start, int receive )
{
  long elapsed = getTimeMark();
  int delta = (miscInfo.state1&StatusLine)==StatusLine ? 0 : 1;

  if( !terminalActive && !rexxTransfer )
  {
    long str;
    int line;
    long ela( elapsed ),
	 size;

    wndQueue = brdColor;

    if( receive )
    {
      char buf[40],
           *ss = strNumber( zInBytes );

      sprintf( buf, "%3d/%s", zInCount, ss );
      wndQueue( 40, 9+delta ).clearLine();
      wndQueue << buf;
      delete ss;

      int percent = (hisFiles+hisMail) ? makePercent( hisFiles+hisMail, zInBytes )
                                       : 101;
      char percentStr[16];

      if( percent>100 )
        strcpy( percentStr, ">100%" );
      else
        sprintf( percentStr, "%lu%%", percent );

      wndQueue( 60, 9+delta ) << percentStr;
      line = 9+delta;
      str = zRecStart;
      size = zInBytes;
    }
    else
    {
      char buf[40],
           *ss = strNumber( zOutBytes );

      sprintf( buf, "%3d/%s", zOutCount, ss );
      wndQueue( 40, 10+delta ).clearLine();
      wndQueue << buf;
      delete ss;

      int percent = (ourFiles+ourMail) ? makePercent( ourFiles+ourMail, zOutBytes )
                                       : 101;
      char percentStr[16];

      if( percent>100 )
        strcpy( percentStr, ">100%" );
      else
        sprintf( percentStr, "%lu%%", percent );

      wndQueue( 60, 10+delta ) << percentStr;
      line = 10+delta;
      str = zTransStart;
      size = zOutBytes;
    }

    ela -= str;

    if( ela <= 0 )
      ela = 1;

    ela = size / ela;

    if( ela<0 )
      ela = 0;

    str = (ela * 1000L) / comPort->getLastBaud();

    wndQueue( 68, line ) << int(ela);

    {
      char buf[64];

      sprintf( buf, "%lu%%", str );
      wndQueue( 74, line ).field( buf );
    }
  }

  elapsed -= startTime;

  long tt( elapsed );

  if( tt < 0 )
    tt = 0;

  if( elapsed <= 0 )
    elapsed = 1;

  elapsed = size / elapsed;

  if( elapsed<0 )
    elapsed = 0;

  long percent = makePercent( comPort->getLastBaud(), elapsed*10 );
  char *ss = strNumber( size );

  if( !start )
    log( receive ? Msg_ZDTotalRec : Msg_ZDTotalSent,
         tt/60, int(tt%60), ss, elapsed, percent );
  else
  {
    char *ss1 = strNumber( start );

    log( receive ? Msg_ZDTotalFromRec : Msg_ZDTotalFromSent,
         tt/60, int(tt%60), ss, ss1, elapsed, percent );
    delete ss1;
  }

  delete  ss;

  if( !receive && telebitFuckinCorrectionTimes )
    log( Msg_InfoFuckinTelebitCorrection );

  if( zWnd==NULL )
    return;

  zWnd->drawTransact( 10, 5, stdColor, Msg_ZDFileDone );
}
