#define INCL_DOSFILEMGR
#include <os2.h>

#include <ctype.h>

#include "language.h"

#include "misc.h"
#include "timer.h"
#include "filetype.h"
#include "key.h"

#include "timeout.h"
#include "zdialog.h"
#include "zinter.h"

char Rxhdr[4];                              // Received header
char Txhdr[4];                              // Transmitted header

long *RXlong = (long *) &Rxhdr[0];
long *TXlong = (long *) &Txhdr[0];

long Strtpos;                               // Starting byte position of
					    //   download
long Rxpos;                                 // Received file position
int Crc32;                                  // Display flag indicating
                                            // 32 bit CRC being used
int Znulls;                                 // # of nulls to send at
                                            // beginning of ZDATA hdr

int Rxtimeout;                              // Tenths of seconds to wait
                                            // for something
int Rxframeind;                             // ZBIN ZBIN32,ZHEX type of
					    // frame received

char *Filename = NULL;                      // name of sending file
long file_length;                           //   and his length
int Resume_WaZOO;			    // if file was resumed
long filetime;                              // timestamp of recv file

char *Upload_path;            // Dest. path of file being received
char *realname = NULL;        // real file name

byte *Txbuf = new byte [ TxBufSize ];       // Pointer to xmit buffer

static int Rxtype;                          // Type of header received

char zmodemActive;
int waZooType;
char zReceiveMode;
char holdForSkipFile = 0;

long zInCount = 0,
     zOutCount = 0,
     zInBytes = 0,
     zOutBytes = 0,
     zTransStart = 0,
     zRecStart = 0;

long zTransferStart = 0;
long zTransferCpsAfter = 60;
int zSendInitBlock = 0;
int sesCpsMinimum = 0;

int zGetTimeOut()
{
  long timeOut( long(miscInfo.timeOut)*300l*100l );
  int Rx( 0 );

  if( timeOuts!=NULL )
  {
    TimeOut test( comPort->getLastBaud(), 0 ),
            *found( timeOuts->Find( test ) );

    if( found!=NULL )
      Rx = found->getTimeOut()*100;
  }

  if( !Rx )
    Rx = int( timeOut / comPort->getLastBaud() );

  if( Rx < 200 )
    Rx = 200;

  if( comPort->isArq() )
    Rx *= 3;

  return Rx;
}

static char *lowHexString = "0123456789abcdef";

inline void Z_PUTHEX( int c )
{
  comPort->putWait( lowHexString[ (c&0xF0)>>4 ], 1 );
  comPort->putWait( lowHexString[ c&0xF ], 1 );
}

unsigned long zfree( char *drive )
{
  unsigned char driveno( 0 );                  // Default drive

  if( drive[0] != '\0' && drive[1] == ':' )
    driveno = char( toupper(*drive) - 'A' + 1 );

  FSALLOCATE FSInfoBuf;
  APIRET  rc;

  rc = DosQueryFSInfo( long( driveno ), FSIL_ALLOC, &FSInfoBuf, sizeof( FSInfoBuf ) );

  if( rc )
  {
    log( Msg_ErrQueryFSInfo, rc );
    os2Message( rc );
    return 0;
  }

  register ULONG retval( FSInfoBuf.cSectorUnit*FSInfoBuf.cUnitAvail*FSInfoBuf.cbSector );
  
  if( !retval )
    return 0;

  register ULONG div( FSInfoBuf.cSectorUnit*FSInfoBuf.cUnitAvail );

  if( div && retval/div!=FSInfoBuf.cbSector )
    return 0x7fffffffl;

  return retval;

/*
  return ((unsigned long)FSInfoBuf.cSectorUnit)*
         FSInfoBuf.cUnitAvail*
         FSInfoBuf.cbSector;
*/
}

int Zabort()
{
  switch( abortAction( zReceiveMode ? 2 : 0 ) )
  {
  case 27:
    log( "?ESC detected" );

/*
    if( !terminalActive && !rexxTransfer ) // flag==1 ???????? (p send)
      comPort->hangUp();
    else
*/
    {
      Timer t( 10000 );

      send_can();

      while( !t.isTimeOut() && !comPort->outEmpty() && comPort->isOnline() )
      {
	comPort->clearin();
	checkPoint();
      }

      send_can();
    }

    return 27;

  case 'c':
    return 'c';

  case 's':
    Window *w( new Window( (Z_ScreenWidth-35)/2+1, (Z_ScreenHeight-5)/2+1,
		 35, 5,
		 Color( colorSet.abort ),
		 Msg_ZDSkipHimTtl, BS_SINGLELINE, DS_LOWERRIGHT ) );

    w->centre( 1, Msg_ZDSkipHim );
    +*w;

    char ch( 0 );
    int oldLeft( 0 );
    char msg[ 80 ];
    Timer t( 10000 );

    while( !t.isTimeOut() && ch!='Y' && ch!='N' )
    {
      int newLeft( t.secsLeft() );

      if( oldLeft!=newLeft )
      {
	oldLeft = newLeft;
	sprintf( msg, Msg_ZDSkipHimLeft, newLeft );
	(*w)( 1, 3 );
	w->clearLine();
	w->centre( 3, msg );
      }

      if( keyPressed() )
	ch = upperChar( keyGet() );

      checkPoint();
    }

    delete w;

    ch = ch=='Y' ? 's' : char(0);

    if( ch=='s' )
    {
      holdForSkipFile = 1;
      log( "?Keyboard SKIP detected" );
    }

    return ch;
  }

  return 0;
}

void send_can()
{
  log( "?Send CAN" );
  comPort->clearout();

  for( int j(0); j<2; j++ )
  {
    for( int i( 0 ); i < 10; i++ )
      comPort->putWait( CAN, 1 );

    for( i = 0; i < 10; i++ )
      comPort->putWait( BS, 1 );

    comPort->putWait( '\r', 1 );
    comPort->putWait( '\n', 1 );
  }

  comPort->clearin();
}

int GetTimedByte( long msec )
{
  register int c;

  c = comPort->get();

  if( c!=-1 )
    return c;

  Timer t( msec );

  do
  {
    c = comPort->get();

    if( c!=-1 )
      return c;

    if( !comPort->isOnline() )
    {
      log( "?GetTimedByte: Carrier lost" );
      return RCDO;
    }

  } while( !t.isTimeOut() );

  log( "?GetTimedByte: Timed out" );
  return TIMEOUT;
}

/*--------------------------------------------------------------------------*/
/* Z PUT STRING                                                             */
/* Send a string to the modem, processing for \336 (sleep 1 sec)            */
/* and \335 (break signal, ignored)                                         */
/*--------------------------------------------------------------------------*/
void Z_PutString( register unsigned char *s )
{
  register unsigned c;

  while( *s )
  {
     switch( c = *s++ )
     {
     case (unsigned int) '\336':
       log( "?Z_PutString: 2sec pause" );
       bigPause( 2 );
       break;

     case (unsigned int) '\335':      // Should send a break on this
       if( comPort->getBreakMode() )
       {
         log( "?Z_PutString: Send break" );
	 comPort->do_break( 1 );
	 bigPause( 1 );
	 comPort->do_break( 0 );
       }
       else
         log( "?Z_PutString: No send break - break disabled" );
       break;

     default:
       comPort->putWait( (unsigned char) c, 1 );
     }

  }

   Z_UncorkTransmitter ();            // Make sure all is well
}

/*--------------------------------------------------------------------------*/
/* Z SEND HEX HEADER                                                        */
/* Send ZMODEM HEX header hdr of type type                                  */
/*--------------------------------------------------------------------------*/
void Z_SendHexHeader( unsigned int type, register unsigned char *hdr )
{
  log( "?Z_SendHexHeader: %s, pos=%lu", headerName( type ), *(long*)hdr );

  Z_UncorkTransmitter();            // Get our transmitter going

  comPort->putWait( ZPAD, 1 );
  comPort->putWait( ZPAD, 1 );
  comPort->putWait( ZDLE, 1 );
  comPort->putWait( ZHEX, 1 );

  Z_PUTHEX( type );

  register word crc;

  crc = word(Z_UpdateCRC( short(type), 0 ));

  for( register int n(4); --n>=0; )
  {
    Z_PUTHEX( *hdr );
    crc = word(Z_UpdateCRC (((unsigned short) (*hdr++)), crc));
  }

  Z_PUTHEX( crc >> 8 );
  Z_PUTHEX( crc );

			     // Make it printable on remote machine
  comPort->putWait( '\r', 1 );
  comPort->putWait( '\n', 1 );

	       // Uncork the remote in case a fake XOFF has stopped data flow
  if( type!=ZFIN && type!=ZACK && waZooType!=DirZap )
    comPort->putWait( 021, 1 );

  if( !comPort->isOnline() )
    comPort->clearout();
}

/*--------------------------------------------------------------------------*/
/* Z UNCORK TRANSMITTER                                                     */
/* Wait a reasonable amount of time for transmitter buffer to clear.        */
/*   When it does, or when time runs out, turn XON/XOFF off then on.        */
/*   This should release a transmitter stuck by line errors.                */
/*--------------------------------------------------------------------------*/

int Z_UncorkTransmitter()
{
  if( comPort->outEmpty() )
    if( !comPort->isOnline() )
      return RCDO;
    else
      return OK;

  Timer t( 10l*Rxtimeout );

  while( !t.isTimeOut() && !comPort->outEmpty() && comPort->isOnline() )
    checkPoint();

  if( t.isTimeOut() )
    log( "?Z_UncorkTransmitter: TIMEOUT" );

  if( !comPort->outEmpty() )
    log( "?Z_UncorkTransmitter: Out not empty" );
  else
    return OK;

  if( !comPort->isOnline() )  //check
  {
    log( "?Z_UncorkTransmitter: DCD low" );
    return RCDO;
  }

  return ERROR;
}


/*--------------------------------------------------------------------------*/
/* Z GET HEADER                                                             */
/* Read a ZMODEM header to hdr, either binary or hex.                       */
/*   On success, set Zmodem to 1 and return type of header.                 */
/*   Otherwise return negative on error                                     */
/*--------------------------------------------------------------------------*/
int Z_GetHeader( byte *hdr )
{
  int cancount( 5 );
  Timer t( 10000l );

Again:

  Rxframeind = 0;
  Rxtype = 0;
  Rxpos = 0;

  register int c;
  int type=-1;

  switch( Zabort() )
  {
  case 27:
    c = USER_ABORT;
    goto Done;

  case 's':
    c = USER_SKIP;
    goto Done;
  }

  switch( c = _Z_TimedRead() )
  {
  case ZPAD:
  case ZPAD | 0200:
			/*-----------------------------------------------*/
			/* This is what we want.                         */
			/*-----------------------------------------------*/
    break;

  case RCDO:
  case TIMEOUT:
  case USER_ABORT:
    goto Done;

  case CAN:
GotCan:

    if( --cancount<=0 )
    {
      c = ZCAN;
      goto Done;
    }

    switch( c=Z_GetByte( 1 ) )
    {
    case TIMEOUT:
      goto Again;

    case ZCRCW:
      c = ERROR;

    // fallthrough...

    case RCDO:
    case USER_ABORT:
      goto Done;

    case CAN:
      if( --cancount<=0 )
      {
	c = ZCAN;
	goto Done;
      }
      goto Again;

    }

    // fallthrough...

  default:

Agn2:
    if( t.isTimeOut() )
    {
      log( Msg_ZErrHdrTimeOut );
      return ERROR;
    }

    if( c!=CAN )
      cancount = 5;

    goto Again;
  }

  cancount = 5;

Splat:
  switch( Zabort() )
  {
  case 27:
    c = USER_ABORT;
    goto Done;

  case 's':
    c = USER_SKIP;
    goto Done;
  }

  switch( c=_Z_TimedRead() )
  {
  case ZDLE:
			/*-----------------------------------------------*/
			/* This is what we want.                         */
			/*-----------------------------------------------*/
    break;

  case ZPAD:
    goto Splat;

  case RCDO:
  case TIMEOUT:
  case USER_ABORT:
    goto Done;

  default:
    goto Agn2;
  }

  switch( type=c=_Z_TimedRead() )
  {

  case ZBIN:
    Rxframeind = ZBIN;
    c = _Z_GetBinaryHeader( hdr );
    break;

  case ZBIN32:
    Rxframeind = ZBIN32;
    c = _Z_32GetBinaryHeader( hdr );
    break;

  case ZHEX:
    Rxframeind = ZHEX;
    c = _Z_GetHexHeader( hdr );
    break;

  case CAN:
    goto GotCan;

  case RCDO:
  case TIMEOUT:
  case USER_ABORT:
    goto Done;

  default:
    goto Agn2;
  }

  Rxpos = _Z_PullLongFromHeader( hdr );

Done:
  log( "?Z_GetHeader: %d: %s/%s, pos=%lu", c, headerName( c ), headerType(type), (unsigned long)Rxpos );
  return c;
}

/*--------------------------------------------------------------------------*/
/* Z GET BINARY HEADER                                                      */
/* Receive a binary style header (type and position)                        */
/*--------------------------------------------------------------------------*/
int _Z_GetBinaryHeader( register unsigned char *hdr )
{
  register int c;

  if( (c = Z_GetZDL()) & ~0xFF )
    return c;

  Rxtype = c;
  register word crc;

  crc = word(Z_UpdateCRC( c, 0 ));

  for( register int n(4); --n >= 0; )
  {
    if( (c = Z_GetZDL()) & ~0xFF )
      return c;

    crc = word(Z_UpdateCRC (c, crc));
    *hdr++ = (unsigned char) (c & 0xff);
  }

  if( (c = Z_GetZDL()) & ~0xFF )
    return c;

  crc = word(Z_UpdateCRC( c, crc ));
  if( (c = Z_GetZDL()) & ~0xFF )
    return c;

  crc = word(Z_UpdateCRC( c, crc ));
  if( crc & 0xFFFF )
  {
    log( Msg_ZErrHdrCRC );
    return ERROR;
   }

  return Rxtype;
}


/*--------------------------------------------------------------------------*/
/* Z GET BINARY HEADER with 32 bit CRC                                      */
/* Receive a binary style header (type and position)                        */
/*--------------------------------------------------------------------------*/
int _Z_32GetBinaryHeader( register unsigned char *hdr )
{
  register unsigned int c;

  if( (c = (unsigned)Z_GetZDL()) & ~0xFF )
     return c;

  Rxtype = c;

  register unsigned long crc( 0xFFFFFFFFl );

  crc = Z_32UpdateCRC( c, crc );

  for( register int n(4); --n >= 0; )
  {
    if( (c = (unsigned)Z_GetZDL()) & ~0xFF )
      return c;

    crc = Z_32UpdateCRC (c, crc);
    *hdr++ = (unsigned char) (c & 0xff);
  }

  for( n = 4; --n >= 0; )
  {
    if( (c = (unsigned)Z_GetZDL()) & ~0xFF )
      return c;

    crc = Z_32UpdateCRC( c, crc );
  }

  if( crc != 0xDEBB20E3l )
  {
    log( Msg_ZErrHdrCRC );
    return ERROR;
  }

  return Rxtype;
}

/*--------------------------------------------------------------------------*/
/* Z GET HEX HEADER                                                         */
/* Receive a hex style header (type and position)                           */
/*--------------------------------------------------------------------------*/
int _Z_GetHexHeader( register unsigned char *hdr )
{
  register int c;

  if( (c = _Z_GetHex()) < 0 )
    return c;

  Rxtype = c;
  register word crc;

  crc = word(Z_UpdateCRC( c, 0 ));

  for( register int n(4); --n >= 0; )
  {
    if( (c = _Z_GetHex()) < 0 )
      return c;

    crc = word(Z_UpdateCRC( c, crc ));
    *hdr++ = (unsigned char) c;
  }

  if( (c = _Z_GetHex()) < 0 )
    return c;

  crc = word(Z_UpdateCRC( c, crc ));
  if( (c = _Z_GetHex()) < 0 )
    return c;

  crc = word(Z_UpdateCRC( c, crc ));
  if( crc & 0xFFFF )
  {
    log( Msg_ZErrHdrCRC );
    return ERROR;
  }

  if( Z_GetByte( 1 ) == '\r' )
  {
    Z_GetByte( 1 );                   // Throw away possible cr/lf
    Z_GetByte( 1 );                   // Throw away possible cr/lf
  }

  return Rxtype;
}

/*--------------------------------------------------------------------------*/
/* Z GET HEX                                                                */
/* Decode two lower case hex digits into an 8 bit byte value                */
/*--------------------------------------------------------------------------*/
int _Z_GetHex()
{
  register int c, n;

  if( (n = _Z_TimedRead()) < 0 )
    return n;

  n -= '0';
  if( n > 9 )
    n -= ('a' - ':');

  if( n & ~0xF )
    return ERROR;

  if( (c = _Z_TimedRead()) < 0 )
    return c;

  c -= '0';
  if( c > 9 )
    c -= ('a' - ':');

  if( c & ~0xF )
    return ERROR;

  return (n << 4) | c;
}

/*--------------------------------------------------------------------------*/
/* Z GET ZDL                                                                */
/* Read a byte, checking for ZMODEM escape encoding                         */
/* including CAN*5 which represents a quick abort                           */
/*--------------------------------------------------------------------------*/
int Z_GetZDL()
{
  register int c;

  if( (c = Z_GetByte( Rxtimeout )) != ZDLE )
    return c;

  c = Z_GetByte( Rxtimeout );

  switch( c )
  {
  case CAN:
     log( "?Z_GetZDL: probably CAN" );
     c =   ((c = Z_GetByte(Rxtimeout)) < 0) ? c :
	   ((c == CAN) && ((c = Z_GetByte(Rxtimeout)) < 0)) ? c :
	   ((c == CAN) && ((c = Z_GetByte(Rxtimeout)) < 0)) ? c : (GOTCAN);

    if( c==(GOTCAN) )
      log( "?Z_GetZDL: found CAN" );
    else
      log( "?Z_GetZDL: CAN not found, stream failed - %02x", c );
    return c;

  case ZCRCE:
  case ZCRCG:
  case ZCRCQ:
  case ZCRCW:
    return c | GOTOR;

  case USER_ABORT:
    return USER_ABORT;

  case ZRUB0:
    log( "?Z_GetZDL: quoted char: ZRUB0" );
    return 0x7F;

  case ZRUB1:
    log( "?Z_GetZDL: quoted char: ZRUB1" );
    return 0xFF;

  default:
    if( c<0 )
    {
      log( "?Z_GetZDL: error flag: %d", c );
      return c;
    }

    if( (c & 0x60) == 0x40 )
    {
//      log( "?Z_GetZDL: quoted char: 0x%02x -> 0x%02x", c, c ^ 0x40 );
      return (c ^ 0x40);
    }

    if( waZooType!=DirZap )
    {
      log( "?Z-BUG: Z_GetZDL: ERROR quoted char: 0x%02x", c );
      return ERROR;
    }

    return (c ^ 0x40);
  }
}

/*--------------------------------------------------------------------------*/
/* Z TIMED READ                                                             */
/* Read a character from the modem line with timeout.                       */
/*  Eat parity, XON and XOFF characters.                                    */
/*--------------------------------------------------------------------------*/
int _Z_TimedRead()
{
  register int c;

  while( 1 )
  {
    if( (c = Z_GetByte( Rxtimeout )) < 0 )
      return c;

    switch( c &= 0x7F )
    {
    case XON:
    case XOFF:
      continue;

    default:
      if( !(c & 0x60) )
	continue;

    // fall

    case '\r':
    case '\n':
    case ZDLE:
      return c;
    }

  }
}

// ------------------------------------

char * headerName( int type )
{
  switch( type )
  {
  case USER_ABORT:
    return "USER_ABORT";
  case ERROR:
    return "ERROR";
  case TIMEOUT:
    return "TIMEOUT";
  case RCDO:
    return "RCDO";
  case FUBAR:
    return "FUBAR";
  case ZPAD:
    return "ZPAD";
  case ZDLE:
    return "ZDLE";
  case ZDLEE:
    return "ZDLEE";
  case ZBIN:
    return "ZBIN";
  case ZHEX:
    return "ZHEX";
  case ZBIN32:
    return "ZBIN32";
  case ZRQINIT:
    return "ZRQINIT";
  case ZRINIT:
    return "ZRINIT";
  case ZSINIT:
    return "ZSINIT";
  case ZACK:
    return "ZACK";
  case ZFILE:
    return "ZFILE";
  case ZSKIP:
    return "ZSKIP";
  case ZNAK:
    return "ZNAK";
  case ZABORT:
    return "ZABORT";
  case ZFIN:
    return "ZFIN";
  case ZRPOS:
    return "ZRPOS";
  case ZDATA:
    return "ZDATA";
  case ZEOF:
    return "ZEOF";
  case ZFERR:
    return "ZFERR";
  case ZCRC:
    return "ZCRC";
  case ZCHALLENGE:
    return "ZCHALLENGE";
  case ZCOMPL:
    return "ZCOMPL";
  case ZCAN:
    return "ZCAN";
  case ZFREECNT:
    return "ZFREECNT";
  case ZCOMMAND:
    return "ZCOMMAND";
  case ZSTDERR:
    return "ZSTDERR";
  case ZCRCE:
    return "ZCRCE";
  case ZCRCG:
    return "ZCRCG";
  case ZCRCQ:
    return "ZCRCQ";
  case ZCRCW:
    return "ZCRCW";
  case ZRUB0:
    return "ZRUB0";
  case ZRUB1:
    return "ZRUB1";
  case GOTOR:
    return "GOTOR";
  case GOTCRCE:
    return "GOTCRCE";
  case GOTCRCG:
    return "GOTCRCG";
  case GOTCRCQ:
    return "GOTCRCQ";
  case GOTCRCW:
    return "GOTCRCW";
  case GOTCAN:
    return "GOTCAN";
  }

  static char buf[32];

  strcpy( buf, "Unknown: 00000" );

  int len = strlen( buf );

  for( int i=0; i<5; i++ )
  {
    buf[ --len ] = char((type%10)+'0');
    type /= 10;
  }

  return buf;
}

char *isProtocolShort( int wazoo )
{
  switch( wazoo )
  {
  case ZedZap:
    return "ZAP";

  case DirZap:
    return "DZA";

  case HydraSes:
    return "HYD";

  case Zmodem:
    return "ZMO";

  default:
    return "???";
  }
}

char *isProtocol( int wazoo )
{
  switch( wazoo )
  {
  case ZedZap:
    return "ZedZap";

  case DirZap:
    return "DirZap";

  case HydraSes:
    return "Hydra";

  case Zmodem:
    return "Zmodem";

  default:
    return "???";
  }
}


char *headerType( int type )
{
  switch( type )
  {
  case ZBIN:
    return "ZBIN";

  case ZBIN32:
    return "ZBIN32";

  case ZHEX:
    return "ZHEX";

  case CAN:
    return "CAN";

  case RCDO:
    return "RCDO";

  case TIMEOUT:
    return "TIMEOUT";

  case ERROR:
    return "ERROR";

  case USER_ABORT:
    return "USER_ABORT";
  }

  static char buf[32];

  strcpy( buf, "Type: 00000" );

  int len = strlen( buf );

  for( int i=0; i<5; i++ )
  {
    buf[ --len ] = char((type%10)+'0');
    type /= 10;
  }

  return buf;
}

void zModemFNC( char *name, int flag )
{
  strcpy( name, fileName( name ) );
  
  if( !flag )
    return;

  char ext[_MAX_EXT];
  char drive[_MAX_DRIVE],
       dir[_MAX_DIR],
       file[_MAX_FNAME];

  _splitpath( name, drive, dir, file, ext );

  char *p( strchr( file, '.' ) );

  if( p )
    *p = 0;
  
  if( strlen(file)>8 )
    file[ 8 ] = 0;
    
  if( strlen(ext)>4 )
    ext[ 4 ] = 0;
    
  strcpy( name, file );
  strcat( name, ext );
}
