/*
  All rights reserved.
  Copyright (c) 1997 by John Gladkih & Bad data, Inc.

  This is partial port of curses to OS/2.

  You may distrubute and change this text as you want.
  You don't remove my copiright. ;-)
*/

#define INCL_DOSPROCESS
#define INCL_KBD
#define INCL_VIO
#include <os2.h>

#include <memory.h>

#include "curses.h"

static int get( void )
{
  APIRET16 ret;
  KBDKEYINFO  info;
  KBDINFO     kinfo;
  int         changed_mode;
  USHORT      old_mask;
  static  unsigned char flag = 255;
  static  unsigned char code;

  if( (flag == 0) || (flag == 0xe0) )
  {
    flag = 255;
    return code;
  }

  kinfo.cb = sizeof(kinfo);

  if( KbdGetStatus(&kinfo,0) == 0 && 
      (kinfo.fsMask & KEYBOARD_BINARY_MODE) != KEYBOARD_BINARY_MODE )
  {
    changed_mode = 1;
    old_mask = kinfo.fsMask;
    kinfo.fsMask = KEYBOARD_BINARY_MODE;
    KbdSetStatus(&kinfo,0);
  }
  else
    changed_mode = 0;

  ret = KbdCharIn(&info, IO_WAIT, 0);

  if( changed_mode )
  {
    kinfo.fsMask = old_mask;
    KbdSetStatus(&kinfo, 0);
  }

  if( ret != 0 )
    return -1;

  if( (info.chChar == 0) || (info.chChar == 0xe0) )
  {
    flag = info.chChar;
    code = info.chScan;
    return 0;
  }

  return info.chChar;
}

static int kbhit( void )
{
  KBDKEYINFO k;
  APIRET16 ret = KbdPeek( &k, 0 );

  return ret != 0 ? 0 : k.fbStatus & KBDTRF_FINAL_CHAR_IN;
}

static waitFlag = 1;

void nodelay( int at, int flag )
{
  waitFlag = !flag;
}

static int get1( void )
{
  int c = get();

  if( !c )
    c = get()<<8;

  return c;
}

int getch( void )
{
  if( waitFlag )
    return get1();
  else if( kbhit() )
    return get1();

   return 0;
}

static int x = 0, y = 0;
static int attr = 0x07;

void move( int _x, int _y )
{
  x = _y;
  y = _x;
}

void attron( int at )
{
  switch( at )
  {
  case A_BOLD:
    attr = 0x0f;
    break;

  case A_REVERSE:
    attr = 0x70;
    break;

  case A_UNDERLINE:
    break;
  }
}

void attroff( int at )
{
  attr = 0x07;
}

void flushinp( void )
{
  while( kbhit() )
    getch();
}

void cbreak( void )
{
}

void noecho( void )
{
}

void keypad(  int at, int flag  )
{
}

void beep()
{
  DosBeep( 1024, 100 );
}

void os2delay( long d )
{
  DosSleep( d );
}


void endwin( void )
{
}

void addch( int ch )
{
  char buf[2];

  buf[1] = (char)attr;
  buf[0] = ch;
  VioWrtCellStr( buf, 2, y, x, 0 );

  if( ++x>79 )
  {
    x -= 80;
    y++;
  }
}

void addstr( char *str )
{
  for( ; *str; str++ )
    addch( *str );
}

void clear( void )
{
  char b[25*80*2];
  int i;

  memset( b, 0x20, sizeof(b) );

  for( i=1; i<sizeof(b); i+=2 )
    b[ i ] = (char)attr;

  VioWrtCellStr( b, sizeof(b), 0, 0, 0 );
}

void clrtoeol( void )
{
  char b[80*2];
  int i;

  memset( b, 0x20, sizeof(b) );

  for( i=1; i<sizeof(b); i+=2 )
    b[ i ] = (char)attr;

  VioWrtCellStr( b, (80-x)<<1, y, x, 0 );
}

void initscr( void )
{
  clear();
}

