#define INCL_DOSPROCESS
#define INCL_DOS
#include <os2.h>

#include <builtin.h>

#include "fsema.h"

FastSema::FastSema()
{
  fast_sem = 0;
}

void FastSema::lock()
{
  PTIB tib;
  PPIB pib;

  DosGetInfoBlocks( &tib, &pib );

  register int tid = tib->tib_ptib2->tib2_ultid;

  while( 1 )
  {
    DosEnterCritSec();

Again:
    int fastlock = __lxchg( &fast_sem, tid );

    if( !fastlock || fastlock==tid )
    {
      DosExitCritSec();
      return;
    }

    fastlock = __lxchg( &fast_sem, fastlock );

    if( !fastlock )
    {
      __lxchg( &fast_sem, 0 );
      goto Again;
    }

    DosExitCritSec();
    DosSleep( 10 );
  }
}

void FastSema::unlock() // Release
{
  PTIB tib;
  PPIB pib;

  DosGetInfoBlocks( &tib, &pib );

  DosEnterCritSec();

  int fastlock = __lxchg( &fast_sem, 0 );

  register int tid = tib->tib_ptib2->tib2_ultid;

  if( fastlock!=tid )
    __lxchg( &fast_sem, fastlock );

  DosExitCritSec();
}

#include <stdio.h>
#include <process.h>
#include <time.h>

volatile abo = 0;
volatile ULONG count = 0;

void _Optlink th( void *t )
{
  while( !abo )
  {
    ((FastSema *)t)->lock();
    ((FastSema *)t)->unlock();
    count++;
  }
}

void main()
{
  FastSema sema;
  long st = time( NULL );

  _beginthread( th, 0, 4096, &sema );

  while( st+10>=time( NULL ) )
    DosSleep( 1 );

  abo = 1;

  printf( "count=%lu\n", count );
}