#ifndef __INBUFFER_H

#define __INBUFFER_H

#include <memory.h>

#include "class.h"

const inBufferSize = 256;

class InputBuffer
{
public:
  char inBuffer[ inBufferSize ];
  unsigned long curInSize;

  InputBuffer( char *b, ULONG s ) : curInSize(s)
    { if( s ) memcpy( inBuffer, b, s ); }

  ~InputBuffer() {}

  int operator == ( const InputBuffer &t ) const
    { return this==&t; }

  friend ostream& operator << ( ostream& o, const InputBuffer& )
    { return o; }
};

class InputBufferList : public OrdinalCollection<InputBuffer>
{
public:
  InputBufferList() : OrdinalCollection<InputBuffer>( 100, 10, SemaphoreModeNeed ) {}
};

class InputBufferIterator : public OrdinalCollectionIterator<InputBuffer>
{
public:
  InputBufferIterator( InputBufferList& ini ) : 
    OrdinalCollectionIterator<InputBuffer>( (OrdinalCollection<InputBuffer>&)ini )
  {}
};

#endif