#ifdef __EMX__

#define INCL_DOSFILEMGR
#include <os2.h>

#include <time.h>
#include <stdlib.h>
#include <string.h>

#include "emx.h"

void randomize()
{ 
  srandom( time(0) );
}

/*
struct date { int da_mon; int da_day; int da_year; };
struct time { int ti_hund; int ti_hour; int ti_min; int ti_sec; };
*/

void getdate( struct date *p )
{
  time_t tt = time( NULL );
  struct tm *tm = localtime( &tt );

  p->da_mon  = tm->tm_mon+1;
  p->da_day  = tm->tm_mday;
  p->da_year = tm->tm_year;
}

void gettime( struct time *p )
{
  time_t tt = time( NULL );
  struct tm *tm = localtime( &tt );

  p->ti_hund = 0;
  p->ti_hour = tm->tm_hour;
  p->ti_min  = tm->tm_min;
  p->ti_sec  = tm->tm_sec;
}

time_t dostounix( struct date *d, struct time *t )
{
/*
  time_t tt = time(0);
  struct tm *tms1 = localtime( &tt );
*/
  struct tm tms;

  memset( &tms, 0, sizeof tms );
  
/*
  memcpy( &tms, tms1, sizeof tms );
*/

  tms.tm_isdst = -1;

  tms.tm_mon  = d->da_mon-1;
  tms.tm_mday = d->da_day;
  tms.tm_year = d->da_year;

  tms.tm_hour = t->ti_hour;
  tms.tm_min  = t->ti_min;
  tms.tm_sec  = t->ti_sec;

  return mktime( &tms );
}

void unixtodos( time_t tt, struct date *d, struct time *t )
{
  struct tm *tm = localtime( &tt );

  t->ti_hund = 0;
  t->ti_hour = tm->tm_hour;
  t->ti_min  = tm->tm_min;
  t->ti_sec  = tm->tm_sec;

  d->da_mon  = tm->tm_mon+1;
  d->da_day  = tm->tm_mday;
  d->da_year = tm->tm_year;
}

int lock( int h, unsigned long off, unsigned long size )
{
  APIRET rc;
  FILELOCK lock;
  FILELOCK unlock;
 
  lock.lOffset = off;
  lock.lRange  = size;

  unlock.lOffset = 0;
  unlock.lRange  = 0;

  rc = DosSetFileLocks( h, &unlock, &lock, 1000, 1 );

  return rc ? -1 : 0;
}

int unlock( int h, unsigned long off, unsigned long size )
{
  APIRET rc;
  FILELOCK lock;
  FILELOCK unlock;
 
  lock.lOffset = 0;
  lock.lRange  = 0;

  unlock.lOffset = off;
  unlock.lRange  = size;

  rc = DosSetFileLocks( h, &unlock, &lock, 1000, 1 );

  return rc ? -1 : 0;
}

/* ᪮., ᯨ᮪, &᪮쪮, ࠧ, 㭪 */

void *lsearch( void *item, void *list, unsigned int *total, size_t size,
               int (*cmp)(void *, void *) )
{
  unsigned int i;
  char *ptr = (char *)list;

  for( i=0; i<*total; i++, ptr += size )
    if( !cmp( item, ptr ) )
      return ptr;

  ++(*total);
  memcpy( ptr, item, size );

  return ptr;
}


#endif
