#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys\stat.h>

#ifndef __EMX__
#include <dir.h>
#endif

#include "busy.h"

const originLen = 76;

void putOrigin()
{

  if( originPtr!=NULL )
  {

    char *oriStr( " * Origin: " ),
	 *stat( new char [256] );
    int len = originLen-strlen(oriStr)+1;

    if( myAddress!=NULL )
      len -= strlen( myAddress )+3;

    if( len<=0 )
    {
      printf( "*FATAL* Too long `-a' argument!\n" );
      returnToDos(4);
    }

    char *origin( new char [ len ] );

    checkPtr( stat );

#ifndef __EMX__
    fseek( originFile, originPtr[ random(originIDXHdr.items) ], SEEK_SET );
#else
    fseek( originFile, originPtr[ random()%originIDXHdr.items ], SEEK_SET );
#endif

    if( fgets( origin, len, originFile )==NULL )
    {
      completeCode = 11;
      printf( "*Error* Can't read origin file\n" );
    }
    else
    {
      register int len( strlen(origin) );

      if( origin[ len-1 ]=='\n' )
        origin[ len-1 ]=0;

      strcpy( stat, oriStr );
      strcat( stat, origin );

      if( myAddress!=NULL )
      {
        strcat( stat, " (" );
        strcat( stat, myAddress );
        strcat( stat, ")" );
      }

      fprintf( statFile, stat );

    }

    delete stat;
    delete origin;

  }

}

void writeIDXHdr( void *r, int size, FILE *file )
{

  rewind( file );

  if( (unsigned)fwrite( r, 1, size, file )!=(unsigned)size )
  {
    printf( "*FATAL* Can't write origin file index header\n" );
    returnToDos( 11 );
  }

}

void compileOrigin()
{

  originFile  = fopen( originName, "r" );

  if( originFile==NULL )
  {
orig_error:
    IOerror( originName );
    returnToDos( 11 );
  }

  char drive[MAXDRIVE], dir[MAXDIR], name[MAXFILE], ext[MAXEXT], idx[MAXPATH];
  char *idxExt( ".ofx" );

  fnsplit( originName, drive, dir, name, ext );
  fnmerge( idx, drive, dir, name, idxExt );

  FILE *idxFile( fopen( idx, access( idx, 0 ) ? "w+b" : "r+b" ) );

  char idxName[ MAXPATH ];

  strcpy( idxName, name );
  strcat( idxName, idxExt );

  if( idxFile==NULL )
  {
    IOerror( idxName );
    returnToDos( 11 );
  }

  struct stat oriStat;

  if( fstat( fileno(originFile), &oriStat ) )
    goto orig_error;

  memset( &originIDXHdr, 0, sizeof(originIDXHdr) );

  if( filelength(fileno(idxFile)) )
    if( fread( &originIDXHdr, 1, sizeof(originIDXHdr), idxFile )!=sizeof(originIDXHdr) )
    {
      printf( "*FATAL* Can't read origin file index header\n" );
      returnToDos( 11 );
    }

  if( originIDXHdr.time!=oriStat.st_mtime ||
      (unsigned)originIDXHdr.len != (unsigned)oriStat.st_size )
  {
    printf( "Compile origin file `%s%s'\n", name, ext );

    originIDXHdr.time = oriStat.st_mtime;
    originIDXHdr.len = oriStat.st_size;
    originIDXHdr.items = 0;
    writeIDXHdr( &originIDXHdr, sizeof(originIDXHdr), idxFile );

    rewind( originFile );

    int ch=0,
        count=0;
    long pos;

    for( pos=0; pos!=-1&&ch!=EOF; pos=ftell( originFile ) )
    {

      for( ch=' ', count=0; ch!=EOF&&ch!='\n'; ch=getc( originFile ) )
        if( ch!=' ' )
          count++;

      if( count )
        if( fwrite( &pos, 1, sizeof(pos), idxFile )!=sizeof(pos) )
        {
          printf( "*FATAL* Can't write origin file index list\n" );
          returnToDos( 11 );
        }
        else
          originIDXHdr.items++;

    }

    if( pos==-1 )
    {
      printf( "*FATAL* Can't get origin file position \n" );
      returnToDos( 11 );
    }

    writeIDXHdr( &originIDXHdr, sizeof(originIDXHdr), idxFile );

  }

  if( originIDXHdr.items )
  {

    printf( "Loading origin file index list `%s'\n", idxName );

    originPtr = new OriginPtr [ originIDXHdr.items ];
    checkPtr( originPtr );

    int len( originIDXHdr.items*sizeof(OriginPtr) );

    fseek( idxFile, sizeof(originIDXHdr), SEEK_SET );

    if( (unsigned)fread( originPtr, 1, len, idxFile )!=(unsigned)len )
    {
      printf( "*FATAL* Can't read origin file index list\n" );
      returnToDos( 11 );
    }

  }
  else
  {

    printf( "Empty origin file `%s%s' skipped\n", name, ext );
    originPtr = NULL;

  }

  fclose( idxFile );

}
